﻿;- globales init etc.

#Title="naMCl"
#Twitch_URL="https://api.twitch.tv/kraken/oauth2/authorize?response_type=token&client_id=qw42otve5jgsdrur8ezl8rvh8k76ebl&redirect_uri=http://game.gpihome.eu/naMCl/&scope=channel_editor+channel_read+channel_commercial+user_read+sdk_broadcast+chat_login+metadata_events_edit"

Global namcl_version.s="3."+Str(#pb_editor_buildcount)+ ReplaceString(FormatDate(".%yy.%mm.%dd",#PB_Compiler_Date),".0",".")

CompilerIf #PB_Compiler_Processor=#PB_Processor_x64
  #linkupdate="http://game.gpihome.eu/naMCl/list64.php"
  #bitver=64
  #bitvers="64"
CompilerElseIf #PB_Compiler_Processor=#PB_Processor_x86
  #linkupdate="http://game.gpihome.eu/naMCl/list32.php"
  #bitver=32
  #bitvers="32"
CompilerEndIf

XIncludeFile "startminecraft2_gzip.pbi"


XIncludeFile "defs.pbi"
XIncludeFile "misc.pbi"
XIncludeFile "net.pbi"
XIncludeFile "json.pbi"
XIncludeFile "serverinfo.pbi"

c$=GetCurrentDirectory()
If Right(c$,1)="\"
  c$=Left(c$,Len(c$)-1)
EndIf
minedir$=c$



Procedure.s CreateGameDir(defgamedir$,id$,type$,curprof$)
  gamedir$=minedir$+"\gamedir\"+defgamedir$
  gamedir$=ReplaceString(gamedir$,"<version>",id$,#PB_String_NoCase)
  ;gamedir$=ReplaceString(gamedir$,"<launcher>","launcher_"+minlauncher$,#PB_String_NoCase)
  gamedir$=ReplaceString(gamedir$,"<type>",type$,#PB_String_NoCase)
  gamedir$=ReplaceString(gamedir$,"<profile>",curprof$,#PB_String_NoCase)
  
  ProcedureReturn gamedir$
EndProcedure


  
Procedure LoadScreenshots(pos)
  Static olddir$
  Static oldpos
  NewList pic.s()
  dir$=GetGadgetText(#gBTN_Gamedir)+"\screenshots\"
  
  If olddir$=dir$ And oldpos=pos
    ;ProcedureReturn #True
  EndIf
  If olddir$<>dir$
    ClearMap( SelectedPic())
  EndIf
  
  d=ExamineDirectory(#PB_Any,dir$,"*.*")
  If d
    While NextDirectoryEntry(d)
      If DirectoryEntryType(d)=#PB_DirectoryEntry_File
        p$=DirectoryEntryName(d)
        e$=UCase(GetExtensionPart(p$))
        If e$="BMP" Or e$="PNG" Or e$="JPG"
          AddElement(pic())
          pic()=p$
        EndIf        
      EndIf
      
    Wend
    FinishDirectory(d)
    SortList(pic(),#PB_Sort_Ascending )
  EndIf
  
  count=ListSize(pic())
  
  
  seiten=(count+ImgCountH*ImgCountW-1)/(ImgCountH*ImgCountW)-1
  If seiten>=0
    SetGadgetAttribute(#gSCR_pic,#PB_ScrollBar_Maximum,seiten)
    SetGadgetAttribute(#gSCR_pic,#PB_ScrollBar_Minimum,0)
    If pos>seiten
      pos=seiten
    EndIf
    
    SetGadgetState(#gScr_pic,pos)
  EndIf
  
  OpenGadgetList(#gPNL_NewsDir,panelScreens)
  nr=pos*ImgCountH*ImgCountW
  For i=0 To #MaxImgCount*#MaxImgCount-1
    If nr<count
      x=i % ImgCountW
      y=i / ImgCountW
      
      If y<ImgCountH
        SelectElement(pic(),nr)
        
        reload=#True
        If IsGadget(#gCON_picstart+i)
          If GetGadgetText(#gTXT_picstart+i)=pic()
            reload=#False
          EndIf
        EndIf
        
        If reload  
          a=LoadImage(#img_start+i,dir$+pic())
        EndIf
        
        neww=ImageWidth(#img_start+I)*(imgh-20)/ImageHeight(#img_start+i)
        If neww>imgw
          newh=ImageHeight(#img_start+i)*imgw/ImageWidth(#img_start+i)
          neww=imgw
        Else
          newh=imgh-20
        EndIf
        
        
        If ImageWidth(#img_start+i)>neww Or ImageHeight(#img_start+i)>newh
          ;Debug Str(ImageWidth(#img_start+i))+"="+Str(neww)+"  "+Str(ImageHeight(#img_start+i))+"="+Str(newh)
          a=ResizeImage(#img_start+i,neww,newh)
          ;Debug "resize "+Str(a)
        EndIf
        
        If IsGadget(#gcon_picstart+i)=#False
          ContainerGadget(#gcon_picstart+i,x*imgw,y*imgh,imgw,imgh,#PB_Container_BorderLess)
          ImageGadget(#gPIC_picstart+i,(imgw-neww)/2,(imgh-20-newh)/2,neww,newh,ImageID(#img_start+i))
          TextGadget(#gTXT_picstart+i,0,imgh-20,imgw,20,pic(), #PB_Text_Center)
          CloseGadgetList()        
        Else
          ResizeGadget(#gcon_picstart+i,x*imgw,y*imgh,imgw,imgh)
          ResizeGadget(#gPIC_picstart+i,(imgw-neww)/2,(imgh-20-newh)/2,neww,newh)
          ResizeGadget(#gTXT_picstart+i,0,imgh-20,imgw,20)
          SetGadgetState(#gPIC_picstart+i,ImageID(#img_start+i))
          SetGadgetText(#gTXT_picstart+i,pic())
        EndIf
        
        
        
        If SelectedPic(pic())=#True
          SetGadgetColor(#gTXT_picstart+i,#PB_Gadget_BackColor,RGB(128,128,255))
          SetGadgetColor(#gcon_picstart+i,#PB_Gadget_BackColor,RGB(128,128,255))
        Else  
          SetGadgetColor(#gTXT_picstart+i,#PB_Gadget_BackColor,RGB(255,255,255))
          SetGadgetColor(#gcon_picstart+i,#PB_Gadget_BackColor,RGB(255,255,255))
        EndIf
      Else
        If IsGadget(#gcon_picstart+i)
          FreeGadget(#gcon_picstart+i)
          FreeImage(#img_start+i)
          ;FreeGadget(#gPIC_picstart+i)
          ;FreeGadget(#gTXT_picstart+i)
        EndIf
        
      EndIf
      
    Else  
      If IsGadget(#gcon_picstart+i)
        FreeGadget(#gcon_picstart+i)
        FreeImage(#img_start+i)
        ;FreeGadget(#gPIC_picstart+i)
        ;FreeGadget(#gTXT_picstart+i)
      EndIf
      
    EndIf
    
    nr+1
  Next
  CloseGadgetList()

  
  olddir$=dir$
  oldpos=pos
  
  
  
EndProcedure

Procedure Load_ResourcePack(forced=#False)
  Static olddir$
  dir$=GetGadgetText(#gBTN_Gamedir)+"\resourcepacks\"
  
  If olddir$=dir$ 
    doload=#False
  Else
    doload=#True
  EndIf
  olddir$=dir$
  
  If doload Or forced
    ClearList(ResourcePack())
    d=ExamineDirectory(#PB_Any,dir$,"*.*")
    If d
      While NextDirectoryEntry(d)
        If DirectoryEntryType(d)=#PB_DirectoryEntry_File
          n$=DirectoryEntryName(d)
          If LCase(Right(n$,4))=".zip" Or LCase(Right(n$,4))=".jar"
            If OpenPack(1,dir$+n$,#PB_PackerPlugin_Zip)
              des$=n$
              If packfind(1,"pack.mcmeta")
                json$=PackLoadJson(1)
                pack$=getkey("pack",@json$)
                des$=GetKey("description",@pack$,n$)
                des$=StringField(des$,1,"\")
              EndIf
              AddElement(ResourcePack())
              ResourcePack()\file=dir$+n$
              If n$<>des$
                ResourcePack()\name=des$
              EndIf              
              
              ClosePack(1)
            EndIf
            
          EndIf
          
        Else
        EndIf
      Wend
      FinishDirectory(d)
    EndIf
  EndIf
  
  ClearGadgetItems(#gLST_Resourcepack)
  ForEach ResourcePack()
    AddGadgetItem(#gLST_Resourcepack,-1,GetFilePart(ResourcePack()\file)+Chr(10)+ResourcePack()\name)
  Next
  For i=0 To 1
    SetGadgetItemAttribute(#gLST_Resourcepack,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
  Next
  
EndProcedure
Procedure Load_ShaderPack(forced=#False)
  Static olddir$
  dir$=GetGadgetText(#gBTN_Gamedir)+"\shaderpacks\"
  
  If olddir$=dir$ 
    doload=#False
  Else
    doload=#True
  EndIf
  olddir$=dir$
  
  If doload Or forced
    ClearList(ShaderPack())
    d=ExamineDirectory(#PB_Any,dir$,"*.*")
    If d
      While NextDirectoryEntry(d)
        If DirectoryEntryType(d)=#PB_DirectoryEntry_File
          n$=DirectoryEntryName(d)
          If LCase(Right(n$,4))=".zip" Or LCase(Right(n$,4))=".jar"
            If OpenPack(1,dir$+n$,#PB_PackerPlugin_Zip)
              des$=n$
              If packfind(1,"pack.mcmeta")
                json$=PackLoadJson(1)
                pack$=getkey("pack",@json$)
                des$=GetKey("description",@pack$,n$)
                des$=StringField(des$,1,"\")
              EndIf
              AddElement(ShaderPack())
              ShaderPack()\file=dir$+n$
              If n$<>des$
                ShaderPack()\name=des$
              EndIf              
              ClosePack(1)
            EndIf
            
          EndIf
          
        Else
        EndIf
      Wend
      FinishDirectory(d)
    EndIf
  EndIf
  
  ClearGadgetItems(#glst_Shaderpack)
  ForEach ShaderPack()
    AddGadgetItem(#glst_Shaderpack,-1,GetFilePart(ShaderPack()\file)+Chr(10)+ShaderPack()\name)
  Next
  For i=0 To 1
    SetGadgetItemAttribute(#glst_Shaderpack,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
  Next
  
EndProcedure

Procedure Load_Mods(forced=#False)
  Static olddir$
  
  For server =0 To 1
    
    If server
      dir$=GetGadgetText(#gBTN_Gamedir)+"\saves\mods\"
    Else
      dir$=GetGadgetText(#gBTN_Gamedir)+"\mods\"
      If olddir$=dir$ 
        doload=#False
      Else
        doload=#True
      EndIf
      olddir$=dir$
    EndIf
    
    
    If doload Or forced
      
      If server
        ClearList(ModsServer())
      Else
        ClearList(Mods())
      EndIf
      
      
      d=ExamineDirectory(#PB_Any,dir$,"*.*")
      If d
        While NextDirectoryEntry(d)
          If DirectoryEntryType(d)=#PB_DirectoryEntry_File
            n$=DirectoryEntryName(d)
            ;debug n$
            If LCase(Right(n$,4))=".zip" Or LCase(Right(n$,4))=".jar"
              If OpenPack(1,dir$+n$,#PB_PackerPlugin_Zip)
                name$=n$
                des$=""
                ver$=""
                mcver$=""
                url$=""
                If packfind(1,"pack.mcmeta")
                  json$=PackLoadJson(1)
                  pack$=getkey("pack",@json$)
                  name$=GetKey("description",@pack$,name$)
                EndIf
                If packfind(1,"mcmod.info")
                  json$=PackLoadJson(1)
                  json$=Mid(json$,2,Len(json$)-2)
                  ;des$=GetKey("description",@pack$,n$)
                  name$=getkey("name",@json$,name$)
                  des$=getkey("description",@json$)
                  ver$=getkey("version",@json$)
                  mcver$=getkey("mcversion",@json$)
                  url$=getkey("url",@json$)                
                EndIf
                If name$="Example Mod"
                  name$=n$
                EndIf
                
                If server
                  
                  AddElement(ModsServer())              
                  ModsServer()\description=des$
                  ModsServer()\file =dir$+n$
                  ModsServer()\mcversion=mcver$
                  ModsServer()\version=version$
                  ModsServer()\name=name$
                  ModsServer()\url=url$
                  ModsServer()\version=ver$
                Else
                  
                  AddElement(mods())              
                  mods()\description=des$
                  mods()\file =dir$+n$
                  mods()\mcversion=mcver$
                  mods()\version=version$
                  mods()\name=name$
                  mods()\url=url$
                  mods()\version=ver$
                EndIf
                ClosePack(1)
              EndIf
              
            EndIf
            
          Else
          EndIf
        Wend
        FinishDirectory(d)
      EndIf
      
    EndIf
  Next

  
  ClearGadgetItems(#gLST_mods)
  ForEach Mods()
    AddGadgetItem(#gLST_Mods,-1,
                  mods()\name+Chr(10)+mods()\version+Chr(10)+mods()\mcversion+Chr(10)+mods()\description)
  Next
  ClearGadgetItems(#gLST_ModsServer)
  ForEach ModsServer()
    AddGadgetItem(#gLST_ModsServer,-1,
                  ModsServer()\name+Chr(10)+ModsServer()\version+Chr(10)+ModsServer()\mcversion+Chr(10)+ModsServer()\description)
  Next
  
   For i=0 To 3
     SetGadgetItemAttribute(#gLST_Mods,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
     SetGadgetItemAttribute(#gLST_ModsServer,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
  Next
EndProcedure


Procedure LoadSaves(forced=#False)
  Static olddir$
  dir$=GetGadgetText(#gBTN_Gamedir)+"\saves\"
  
  If olddir$=dir$ 
    doload=#False
  Else
    doload=#True
  EndIf
  olddir$=dir$
  
  If doload Or forced
    ClearList(saves())
    a=ExamineDirectory(#PB_Any,dir$,"*.*")
    If a
      While NextDirectoryEntry(a)
        If DirectoryEntryType(a)=#PB_DirectoryEntry_Directory
          a$=DirectoryEntryName(a)
          If a$<>"." And a$<>".."
            ;Debug "save:"+a$
            If loadntb(dir$+a$+"\level.dat")
              ;Debug "loadntb"
              AddElement(saves())
              With saves()
                \dir=a$           
                \hasdifficultylock=Bool(FindMapElement(ntb(),"\Data\DifficultyLocked")<>0)
                \hashardcore=Bool(FindMapElement(ntb(),"\Data\hardcore")<>0)
                \levelname=NTB_GetValueS("\Data\LevelName")
                \hardcore=ntb_getvalue("\Data\hardcore")
                If FindMapElement(ntb(),"\Data\Difficulty")
                  \difficulty=ntb_getvalue("\Data\Difficulty")
                Else
                  \difficulty=-1
                EndIf
                
                \difficultylocked=ntb_getvalue("\Data\DifficultyLocked")
                \gametype=ntb_getvalue("\Data\GameType")
                \allowcommands=NTB_GetValue("\Data\allowCommands")
                \invulnerable=NTB_GetValue("\Data\Player\Invulnerable")
                \lastplayed=ntb_getvalue("\Data\LastPlayed")
                \randomseed=ntb_Getvalue("\Data\RandomSeed")
                \generatorname=ntb_getvalues("\Data\generatorName")
                \GeneratorOptions.s=ntb_getvalues("\Data\generatorOptions")
                \GenerateStructures=ntb_Getvalue("\Data\MapFeatures")
                
              EndWith
              
            EndIf
          EndIf
          
        EndIf
      Wend  
      FinishDirectory(a)
    EndIf
    
    freentb()
  EndIf
  
  ClearGadgetItems(#gLST_Save)
  ForEach saves()
    e$=saves()\levelname
    If saves()\levelname<>saves()\dir
      e$+" ["+saves()\dir+"]"
    EndIf
    e$+Chr(10)
    If saves()\difficultylocked
      e$+"["
    EndIf
    
    If saves()\hardcore
      e$+"Hardcore"
    Else
      e$+StringField("unknown;Peaceful;Easy;Normal;Hard;4;5;6;<>",saves()\difficulty+2,";")
    EndIf
    If saves()\difficultylocked
      e$+"]"
    EndIf
    
    e$+Chr(10)
    
    e$+StringField("Survival;Creative;Adventure;Spectator;4;5;6;7",saves()\gametype+1,";")+Chr(10)
    e$+StringField("-;enabled",saves()\allowcommands+1,";")+Chr(10)
    e$+StringField("-;enabled",saves()\invulnerable+1,";")+Chr(10)
    
    e$+saves()\generatorname+Chr(10)
    e$+StrU(saves()\randomseed)+Chr(10)
    e$+FormatDate("%dd.%mm.%yyyy %hh:%ii",saves()\lastplayed/1000)
    
    AddGadgetItem(#gLST_Save,-1,e$)
  Next
  
  
  
  SetGadgetItemAttribute(#gLST_Save,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE,0)
  x=GetGadgetItemAttribute(#gLST_Save,0,#PB_ListIcon_ColumnWidth,0)
  If x<200
    SetGadgetItemAttribute(#gLST_Save,0,#PB_ListIcon_ColumnWidth,200,0)
  EndIf  
  
  For i=1 To 5
    SetGadgetItemAttribute(#gLST_Save,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
  Next
  SetGadgetItemAttribute(#gLST_Save,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE,6)
  SetGadgetItemAttribute(#gLST_Save,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE,7)
  
  
EndProcedure
Procedure SavesAsServer(x)
  ;debug "startasserver"
  SelectElement(mines(),GetGadgetState(#gCBX_Version))
  ver$=mines()\dir
  ;debug ver$
  If ver$="current"
    ver$=curver$
  EndIf
  If ver$="current_snap"
    ver$=cursnap$
  EndIf
  
  
  java$=GetGadgetText(#gSTR_JavaExe)
  serverjar$=minedir$+"\versions\"+ver$+"\minecraft_server."+ver$+".jar"          
  If GetGadgetState(#gCHK_ServerPRGArg)
    javaarg$=GetGadgetText(#gSTR_ServerPRGArg)
  Else
    javaarg$=""
  EndIf
    
  SelectElement(saves(),x)
  dir$=GetGadgetText(#gBTN_Gamedir)+"\saves\"
  NewMap file$()
  If ReadFile(10,dir$+"server.properties")
    While Not Eof(10)
      a$=ReadString(10)
      file$(StringField(a$,1,"="))=StringField(a$,2,"=")
    Wend
    CloseFile(10)
  EndIf
  
  file$("generator-settings")=saves()\GeneratorOptions
  file$("level-name")=saves()\dir
  file$("level-type")=saves()\generatorname
  file$("level-seed")=StrU(saves()\randomseed)
  file$("allow-nether")="true"
  
  If saves()\difficulty>=0
    file$("difficulty")=Str(saves()\difficulty)
  Else
    file$("difficulty")="1"
  EndIf
  file$("enable-command-block")="true"
  file$("gamemode")=Str(saves()\gametype)
  file$("generate-structures")=StringField("false;true",saves()\GenerateStructures+1,";")
  
  
  ForEach ServerOptions()
    file$(ServerOptions()\key)=ServerOptions()\value
  Next
  
  If CreateFile(10,dir$+"server.properties")
    ForEach file$()
      k$=MapKey(file$())
      If k$<>"" And Left(a$,1)<>"#"
        WriteStringN(10,k$+"="+file$())
      Else
        WriteStringN(10,k$)
      EndIf      
    Next
    CloseFile(10)
  EndIf
  If FileSize(dir$+"eula.txt")<=0
    If CreateFile(10,dir$+"eula.txt")
      WriteStringN(10,"eula=true")
      CloseFile(10)
    EndIf
  EndIf
  RunProgram(java$,
             javaarg$+" -jar "+Chr(34)+serverjar$+Chr(34),
             dir$)      
  
  
EndProcedure

Procedure ListIconAddImage(gad,pos,*mem)
  ;debug "listiconaddimage"
  If servers_imagelist=0
    servers_imagelist= ImageList_Create_(32,32, #ILC_COLOR32, 0, 30)
    SendMessage_(GadgetID(gad), #LVM_SETIMAGELIST, #LVSIL_SMALL, servers_imagelist)
  EndIf
  ;debug servers_imagelist
  If *mem
    
    TransparentIco.l = CatchImage(#PB_Any, *mem)
    If TransparentIco
      If ImageWidth(TransparentIco)<>32 Or ImageHeight(TransparentIco)<>32
        ResizeImage(TransparentIco,32,32)
      EndIf
      
      ;debug  "bild geladen!"
      IndexTransparentIco = ImageList_Add_(servers_imagelist,ImageID(TransparentIco),0);   Icon_(servers_imagelist,ImageID( TransparentIco))
      FreeImage(TransparentIco)
    Else
      IndexTransparentIco=-1
    EndIf
    ;debug IndexTransparentIco
  Else
    IndexTransparentIco=-1
  EndIf

  
  var.lvitem
  Var\mask = #LVIF_IMAGE 
  Var\iItem = pos         ; row number
  Var\iSubItem = 0   ; subitem
  Var\pszText = @"testit"   ; text to set
  Var\iImage = IndexTransparentIco ; index of icon in the list

  ; set text + icon in the listicongadget item/subitem
  SendMessage_(GadgetID(Gad), #LVM_SETITEM, 0, @Var)
    
    
  ProcedureReturn IndexTransparentIco
EndProcedure
Procedure clear_ListIconImages()
  If servers_imagelist
    ImageList_Destroy_(servers_imagelist)
    servers_imagelist=0
  EndIf  
EndProcedure


Procedure Clear_ServersList()
  servers_threadaktiv=#False
  If IsThread(servers_thread)
    WaitThread(servers_thread,600)
    If IsThread(servers_thread) 
      KillThread(servers_thread)
    EndIf
  EndIf      
      
 
  ClearList(servers())
  ClearGadgetItems(#gLST_Servers)
  clear_ListIconImages()
EndProcedure


Procedure ThreadServersList(null)
  ForEach servers()
    ;Delay(1)
    If servers_threadaktiv=#False
      Break
    EndIf
        
    ip$=StringField(servers()\ip,1,":")
    port=Val(StringField(servers()\ip,2,":"))
    If port=0
      port=25565
    EndIf
    
    json$=GetServerInfo(ip$,port)
    
    If servers_threadaktiv
      version$=getkey("version",@json$)
      SetGadgetItemText(#gLST_Servers,servers()\itempos,getkey("name",@version$,"-"),2)
      player$=getkey("players",@json$,"")
      SetGadgetItemText(#glst_servers,servers()\itempos,getkey("online",@player$,"0")+"/"+getkey("max",@player$,"0"),3)
      SetGadgetItemText(#gLST_Servers,servers()\itempos,getkey("ping",@json$,"-"),4)
      a$=getkey("description",@json$,"")
      Repeat
        l=Len(a$)
        a=FindString(a$,"§")
        If a
          a$=Left(a$,a-1)+Right(a$,Len(a$)-a-1)
        EndIf
        a=FindString(a$,"\u")
        If a
          b.l=Val("$"+Mid(a$,a+3,4))
          a$=Left(a$,a-1)+PeekS(@b,1,#PB_Unicode)+Right(a$,Len(a$)-a-5)
        EndIf
        a$=ReplaceString(a$,"\n",Chr(13))
        a$=ReplaceString(a$,"    ","   ")
      Until l=Len(a$)
      a$=ReplaceString(a$,"   ",Chr(13))
      
      SetGadgetItemText(#glst_servers,servers()\itempos,a$,5)
      For i=0 To 5
        SetGadgetItemAttribute(#gLST_Servers,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
      Next
    EndIf
  Next
  For i=0 To 5
    SetGadgetItemAttribute(#gLST_Servers,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
  Next
  servers_threadaktiv=#False
EndProcedure

  
  
  
Procedure LoadServersList()
  ;debug "--- server.dat"
  dir$=GetGadgetText(#gBTN_Gamedir)+"\"
  Clear_ServersList()
  
  If LoadNTB(dir$+"servers.dat",#False)
    ;debugntb()
    
    ;debug "----"
    i=1
    Repeat
      key$="\servers."+Str(i)+"\"
      ;debug key$
      If FindMapElement(ntb(),key$+"ip")
        ;debug "add server"
        AddElement(servers())
        
              
        
        servers()\name=NTB_GetValueS(key$+"name")
        servers()\ip=NTB_GetValueS(key$+"ip")   
        If servers()\images
          id=ImageID(servers()\images)
        Else
          id=0
        EndIf
        
        
        
          
        AddGadgetItem(#gLST_Servers,-1,servers()\name+Chr(10)+servers()\ip+Chr(10)+"999/999"+Chr(10)+"999",id)
        
        If FindMapElement(ntb(),key$+"icon")
          b64$=NTB_GetValueS(key$+"icon")
          *b64=AllocateMemory(Len(b64$)*2)
          mlen=Base64Decoder(@b64$,Len(b64$),*b64,Len(b64$)*2-1) 
          ;servers()\images=CatchImage(#PB_Any,*b64,mlen)
          ListIconAddImage(#gLST_Servers,i-1,*b64)
          
          FreeMemory(*b64)
        Else
          ListIconAddImage(#gLST_Servers,i-1,0)
        EndIf  
        
        
        
        servers()\itempos=i-1        
        
      Else
        Break
      EndIf
      i+1
    ForEver
    
    FreeNTB()
    
    servers_threadaktiv=#True
    servers_thread=CreateThread(@ThreadServersList(),0)
    
    
  EndIf
  
      
EndProcedure

Procedure changeGameDir()
  
  SelectElement(profiles(),GetGadgetState(#gLST_Profile))
  
  ForEach mines()
    If profiles()\ver=mines()\dir
      id$=mines()\id
      type$=mines()\type
      ;debug "found"
      Break
    EndIf
  Next
  
  dir$= creategamedir(GetGadgetText(#gCBX_Dir),id$,type$,profiles()\title)
  SetGadgetText(#gBTN_Gamedir,dir$)
  LoadScreenshots(0)
  LoadSaves()
  Load_ResourcePack()
  Load_ShaderPack()
  Load_Mods()
  LoadServersList()
  resize_win0(#True)
  
  
EndProcedure

Procedure.s DisplayProfile(x)
  SetGadgetState(#gLST_Profile,x)
  SelectElement(profiles(),x)
  lastprof=x
  i=0
  ok=#False
  ForEach mines()
    If profiles()\ver=mines()\dir
      SetGadgetState(#gCBX_Version,i)
      ok=#True
      Break
    EndIf
    i+1
  Next
  
  If ok=#False
    Debug "****************** NOT FOUND!!!!"
  EndIf
  
  
  SetGadgetText(#gSTR_Name,profiles()\minename)
  SetGadgetText(#gSTR_JavaExe,profiles()\prg)
  SetGadgetText(#gSTR_JavaArg,profiles()\prgarg)
  SetGadgetText(#gCBX_Dir,profiles()\gamedir)
  SetGadgetText(#gSTR_Password,profiles()\password)
  SetGadgetText(#gSTR_ServerPRGArg,profiles()\Serverprgarg)
  SetGadgetState(#gCHK_BorderlessWindow,profiles()\BorderlessWindow)
  SetGadgetText(#gSTR_ServerIP,profiles()\server)
  SetGadgetState(#gCHK_JavaArg,profiles()\doPrgArg)
  SetGadgetState(#gCHK_ServerPRGArg,profiles()\doServerPrgArg)
  SetGadgetState(#gCHK_ServerIP,profiles()\doServer)
  
  SetGadgetText(#gHST_lastlogin,profiles()\lastlogin)
  SetGadgetText(#gHST_lastminename,profiles()\lastminename)
  SetGadgetText(#gHST_lastuuid,profiles()\lastuuid)
  SetGadgetText(#gHST_lastusertype,profiles()\lastusertype)

  
  If x<2
    DisableGadget(#gCBX_Version,#True)
  Else
    DisableGadget(#gCBX_Version,#False)
  EndIf
    
  changeGameDir()
EndProcedure
Procedure.s StoreProfile(x)
  SelectElement(profiles(),x)
  SelectElement(mines(),GetGadgetState(#gCBX_Version))
  profiles()\ver=mines()\dir
  profiles()\minename=GetGadgetText(#gSTR_Name)
  profiles()\prg=GetGadgetText(#gSTR_JavaExe)
  profiles()\prgarg=GetGadgetText(#gSTR_JavaArg)
  profiles()\gamedir=GetGadgetText(#gCBX_Dir)
  profiles()\password=GetGadgetText(#gSTR_Password)
  profiles()\Serverprgarg=GetGadgetText(#gSTR_ServerPRGArg)
  profiles()\BorderlessWindow=GetGadgetState(#gCHK_BorderlessWindow)
  profiles()\server=GetGadgetText(#gSTR_ServerIP)
  profiles()\doPrgArg=GetGadgetState(#gCHK_JavaArg)
  profiles()\doServerPrgArg=GetGadgetState(#gCHK_ServerPRGArg)
  profiles()\doServer=GetGadgetState(#gCHK_ServerIP)
  
  profiles()\lastlogin=GetGadgetText(#gHST_lastlogin)
  profiles()\lastminename=GetGadgetText(#gHST_lastminename)
  profiles()\lastuuid=GetGadgetText(#gHST_lastuuid)
  profiles()\lastusertype=GetGadgetText(#gHST_lastusertype)
    
EndProcedure
Procedure NavigationCallback(Gadget, Url$)
  ;
  ; Geben Sie #True zurück, um diese Navigation zu erlauben, oder #False um sie zu unterbinden.
  ;-- minecraftforge
  
  If Left(url$,58)="http://adf.ly/673885/http://files.minecraftforge.net/maven"
    ;Debug "FORGE FOUND! "+Right(url$,Len(url$)-21)
    url$=Right(url$,Len(url$)-21)
    doads=#True
  EndIf    
  
  If Left(url$,37)="http://files.minecraftforge.net/maven"
    name$=GetFilePart(url$)
    If Right(name$,14)="-installer.jar"
      name$=Left(name$,Len(name$)-14)
      OpenWinInfo("Forge "+name$)
      WinInfo2("download")
      temp$=GetTemporaryDirectory()+name$+".jar"
      ;Debug "url:"+url$
      ;Debug "temp:"+temp$
      If getfile(url$,temp$)
        ;Debug "Datei gedownloaded"
        If OpenPack(1,temp$,#PB_PackerPlugin_Zip)
          ;Debug "examine pack"
          If PackFind(1,"install_profile.json")
            
            
            json$=PackLoadJson(1)
            
            
            
            versioninfo$=getkey("versionInfo",@json$)
            id$=getkey("id",@versioninfo$)
            
            
            install$=getkey("install",@json$)
            minver$=getkey("minecraft",@install$)
            
            
            lib$=getkey("path",@install$)
            libpack$=StringField(lib$,1,":")
            libname$=StringField(lib$,2,":")
            libver$=StringField(lib$,3,":")
            file$=minedir$+"\libraries\"+ReplaceString(libpack$,".","_")+"_"+libname$+"-"+libver$+".jar"
            jar$=getkey("filePath",@install$)
            wininfo2("uncompress Forge")
            a=UncompressPackFile(1,file$,jar$)
            
            
            
            CreateDirectory(minedir$+"\versions\"+id$)
            wininfo2("download minecraft")
            GetFile("http://s3.amazonaws.com/Minecraft.Download/versions/"+minver$+"/"+minver$+".jar",minedir$+"\versions\"+id$+"\"+id$+".jar")
            wininfo2("download server")
            ;GetFile("http://s3.amazonaws.com/Minecraft.Download/versions/"+minver$+"/minecraft_server."+minver$+".jar",minedir$+"\versions\"+id$+"\minecraft_server."+minver$+".jar",#False)
            ;GetFile("http://s3.amazonaws.com/Minecraft.Download/versions/"+ver$+"/"+ver$+".json",minedir$+"\versions\"+ver$+"\"+ver$+".json")
            If CreateFile(1,minedir$+"\versions\"+id$+"\"+id$+".json")
              WriteStringN(1,"{ "+versioninfo$+" }")
              CloseFile(1)
            EndIf
            
            WinInfo2("install server")
            RunProgram(GetGadgetText(#gSTR_JavaExe),"-jar "+Chr(34)+temp$+Chr(34)+" --installServer",minedir$+"\versions\"+id$+"\",#PB_Program_Wait)
            
            Debug "test"
            ;file$=SearchFile(minedir$+"\versions\"+id$+"\minecraftforge*.jar")
            ;If file$=""
            ;  file$=SearchFile(minedir$+"\versions\"+id$+"\forge*.jar")
            ;EndIf
            
            file$=minedir$+"\versions\"+id$+"\"+jar$
            
            Debug file$
            If file$
              RenameFile(file$,minedir$+"\versions\"+id$+"\minecraft_server."+id$+".jar")
            EndIf
            
            
          EndIf
          
          
          ClosePack(1)
        EndIf
        
        
        
        DeleteFile(temp$)
      EndIf
      
      CloseWinInfo()
      
      ;a$=GetGadgetText(#gCBX_Version)
      StoreProfile(lastprof)
      Scan_Mines()
      Build_Mines()      
      DisplayProfile(lastprof)
      ;i=0
      ;ForEach mines()
      ;  If mines()\id=a$
      ;    SetGadgetState(#gCBX_Version,i)
      ;    Break
      ;  EndIf
      ;  i+1
      ;Next
      
    EndIf
    If doads
      SetGadgetText(gadget,"http://adf.ly/673885/http://files.minecraftforge.net")
    Else
      SetGadgetText(gadget,"http://files.minecraftforge.net")
    EndIf
    
    ProcedureReturn #False
  EndIf
  
  x=gadget-#gweb_start
  SetGadgetText(#gWeb_URL+x,GetGadgetText(gadget))
  
  If url$="about:blank" Or FindString(url$,"javascript") Or FindString(url$,"betrad.com") Or FindString(url$,"doubleclick.net/") Or FindString(url$,"google.com") Or FindString(url$,"mediaplex.com") Or FindString(url$,"pubmatic.com")Or FindString(url$,"turn.com") Or FindString(url$,"openx.net") Or FindString(url$,"googlesyndication.com") Or FindString(url$,"quantserve.com") Or FindString(url$,"rubiconproject.com") Or FindString(url$,"doubleverify.com")
    ProcedureReturn #False
  ElseIf (GetAsyncKeyState_(#VK_CONTROL) & $8000)
    RunProgram(url$)
    ProcedureReturn #False
  ElseIf FindString(url$,"gamepedia.com")  And #False  
    If FindString(url$,"mobileaction=toggle_view_mobile")=0
      If FindString(url$,"?")=0
        SetGadgetText(gadget,url$+"?mobileaction=toggle_view_mobile")
      Else
        SetGadgetText(gadget,url$+"&mobileaction=toggle_view_mobile")
      EndIf      
      ProcedureReturn #False
    EndIf
  EndIf
  Debug "NavCallback:"+Str(gadget-#gweb_start)+" "+url$
    
  
  ProcedureReturn #True
EndProcedure


Procedure saves_backup(dir$,sub$,dest$)
  NewList dirs.s()
  AddElement(dirs())
  dirs()=sub$+"\"
  OpenWinInfo("Backup "+sub$)
  
  If CreatePack(1,dest$)
    While FirstElement(dirs())
      sdir$=dirs()
      d=ExamineDirectory(#PB_Any,dir$+sdir$,"*.*")
      If d
        While NextDirectoryEntry(d)
          n$=DirectoryEntryName(d)
          If DirectoryEntryType(d)=#PB_DirectoryEntry_Directory
            If n$<>"." And n$<>".."
              AddElement(dirs())
              dirs()=sdir$+n$+"\"
              ;AddPackFile(1,dir$+sdir$+n$,sdir$+n$)
            EndIf
          Else
            wininfo2("Add "+sdir$+n$)
            AddPackFile(1,dir$+sdir$+n$,sdir$+n$)
          EndIf        
        Wend      
        FinishDirectory(d)
      EndIf
      
      
      FirstElement(dirs())
      DeleteElement(dirs())
    Wend
    wininfo2("Compress...")
    ClosePack(1)
  EndIf
  CloseWinInfo()
EndProcedure
Procedure saves_createstruc(sub$)
  forceDirectories(sub$+"data")
  CreateDirectory(sub$+"DIM1")
  CreateDirectory(sub$+"DIM-1")
  CreateDirectory(sub$+"playerdata")
  CreateDirectory(sub$+"region")
  CreateDirectory(sub$+"stats")
EndProcedure
Procedure resize_win0(forced=#False)
  Static oldw,oldh,oldforced
  
  If WindowWidth(0)=oldw And WindowHeight(0)=oldh
    If forced=#True And oldforced=#False
      For i=0 To #MaxImgCount*#MaxImgCount-1
        If IsGadget(#gtxt_picstart+i)
          SetGadgetText(#gTXT_picstart+i,"*")
        EndIf
      Next
      LoadScreenshots(GetGadgetState(#gSCR_pic))
      oldforced=#True
    EndIf
  Else
    oldforced=forced
    oldw=WindowWidth(0)
    oldh=WindowHeight(0)
  EndIf
  
  
  ;settinghight=110+40+5
  ;ResizeGadget(#gPNL_Settings,0,WindowHeight(0)-settinghight-25,WindowWidth(0),settinghight)
  ;ResizeGadget(#gLST_Profile,GadgetWidth(#gPNL_Settings),5,WindowWidth(0)-GadgetWidth(#gPNL_Settings),GadgetHeight(#gPNL_Settings))
  
  settinghight=20+5+20+5+20+5+20
  w=GadgetWidth(#gpnl_settings) + (400-GetGadgetAttribute(#gpnl_settings,#PB_Panel_ItemWidth))
  h=GadgetHeight(#gpnl_settings) + (settinghight-GetGadgetAttribute(#gpnl_settings,#PB_Panel_ItemHeight))
  ResizeGadget(#gPnl_Settings,1,WindowHeight(0)-h,w,h)
  
  ResizeGadget(#gLST_Profile,GadgetWidth(#gPNL_Settings)+1,GadgetY(#gPNL_Settings),WindowWidth(0)-GadgetWidth(#gPNL_Settings)-2-100,GadgetHeight(#gPNL_Settings)-1)
  w=GadgetX(#gLST_Profile)+GadgetWidth(#glst_profile)
  ResizeGadget(#gBTN_Start,w+1,GadgetY(#gLST_Profile),WindowWidth(0)-w-1,GadgetHeight(#gLST_Profile))
  
  
  
  ResizeGadget(#gWeb_Twitch,1,1,WindowWidth(0),GadgetY(#gPNL_Settings)-1)
  ResizeGadget(#gPNL_NewsDir,1,1,WindowWidth(0),GadgetY(#gPNL_Settings)-1)
  w=GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemWidth)
  h=GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemHeight)
  
  For i=#gWeb_Start To #gWeb_end
    If IsGadget(i)
      ResizeGadget(i,0,20,w,h-20)
      ResizeGadget(#gWeb_URL+i-#gWeb_Start,40,0,w-40,20)
    EndIf    
  Next
  
  
  ResizeGadget(#gBTN_Gamedir,0,0,w,20)
  
  
  ResizeGadget(#gSCR_pic,w-21,0,20,h)
  
  ;debug UCase(GetGadgetText(#gCBX_Version))
  If FindString(UCase(GetGadgetText(#gCBX_Version)),"FORGE")=0
    c=2:l=1
  Else
    c=3:l=2
  EndIf
  ResizeGadget(#gLST_Save,0,20,w,(h-20)/c)
  ResizeGadget(#gLST_Resourcepack,0,20+(h-20)/c,w/l,(h-20)/c)
  If c=2
    HideGadget(#gLST_Mods,#True)
    HideGadget(#gLST_ModsServer,#True)
    HideGadget(#glst_Shaderpack,#True)
  Else    
    ResizeGadget(#gLST_Mods,0,20+(h-20)*2/c,w/2,(h-20)/c)
    ResizeGadget(#gLST_ModsServer,w/2,20+(h-20)*2/c,w/2,(h-20)/c)
    ResizeGadget(#glst_Shaderpack,w/2,20+(h-20)/c,w/2,(h-20)/c)
    HideGadget(#glst_mods,#False)
    HideGadget(#gLST_ModsServer,#False)
    HideGadget(#glst_Shaderpack,#False)
  EndIf
  
  
  
  imgw=215
  imgh=112
  
  ImgCountW=(w-20)/imgw
  imgcountH=h/imgh
  Imgw=(w-20)/imgcountw
  Imgh=h/imgcounth
   
  
  ;Debug imgw
  ;Debug imgh
  ;CreateImage(#img_blank,imgw,imgh-20,24,RGB(255,255,255))
  If forced=#False
    
;     For i=0 To #MaxImgCount*#MaxImgCount-1
;       x=i % ImgCountW
;       y=i / ImgCountW
;       If y<ImgCountH
;         g=y*imgcountw+x
;         If IsGadget(#gcon_picstart+g)
;           ResizeGadget(#gcon_picstart+g,x*imgw,y*imgh,imgw,imgh)
;           ResizeGadget(#gPIC_picstart+g,(imgw-ImageWidth(#img_start+g))/2,(imgh-ImageHeight(#img_start+g)-20)/2,imgw,imgh-20)
;           ResizeGadget(#gTXT_picstart+g,0,imgh-20,imgw,20)
;         EndIf
;       Else
;         If IsGadget(#gcon_picstart+g)
;           ;FreeGadget(#gcon_picstart+g)
;           ;FreeImage(#img_start+g)
;           ;FreeGadget(#gPIC_picstart+g)
;           ;FreeGadget(#gTXT_picstart+g)
;         EndIf
;       EndIf
;     Next
  Else 
    For i=0 To #MaxImgCount*#MaxImgCount-1
      If IsGadget(#gtxt_picstart+i)
        SetGadgetText(#gTXT_picstart+i,"*")
      EndIf
    Next
    LoadScreenshots(GetGadgetState(#gSCR_pic))
    oldforced=#True
  EndIf
  
  For i=0 To 1
    SetGadgetItemAttribute(#gLST_Resourcepack,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
    SetGadgetItemAttribute(#glst_Shaderpack,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,i)
  Next
  
  ResizeGadget(#gLST_Servers,0,0,w,h)
  SetGadgetItemAttribute(#gLST_Servers,0,#PB_ListIcon_ColumnWidth,#LVSCW_AUTOSIZE_USEHEADER,5)
  
  
EndProcedure


Procedure MyWindowCallback(WindowID, Message, wParam, lParam)
  Result = #PB_ProcessPureBasicEvents
  If IsWindow(0)
    If windowid=WindowID(0)
      If message=#WM_SIZING
        resize_win0()
      EndIf
      
    EndIf
    
  EndIf
  
  ProcedureReturn Result
EndProcedure
Procedure Build_Profiles(curprof$)
  i=0:lastprof=0
  ClearGadgetItems(#gLST_Profile)
  ForEach profiles()
    AddGadgetItem(#gLST_Profile,-1,profiles()\title)
    If profiles()\title=curprof$
      lastprof=i
    EndIf
    
    i+1
  Next

  DisplayProfile(lastprof)
EndProcedure
Procedure Build_Mines()
  ClearGadgetItems(#gCBX_Version)
  ForEach mines()
    ;Debug mines()\id+"  "+mines()\dir+"  "+mines()\type+"  "+Str(mines()\time)
    ;AddGadgetItem(#gCBX_Version,-1,mines()\type+" "+mines()\id)
    If mines()\dir<>mines()\id
      AddGadgetItem(#gCBX_Version,-1,mines()\type+" "+mines()\id+" ["+mines()\dir+"]");           ("+FormatDate("%dd.%mm.%yyyy",mines()\time)+")")
    Else
      AddGadgetItem(#gCBX_Version,-1,mines()\type+" "+mines()\id);+Space(40),40)+Chr(10)+"("+FormatDate("%dd.%mm.%yyyy",mines()\time)+")")
    EndIf
    
  Next
  SetGadgetState(#gCBX_Version,0)
EndProcedure
Procedure Scan_Mines()
  If ExamineDirectory(1,minedir$+"\versions\","*.*")
    While NextDirectoryEntry(1)
      If DirectoryEntryType(1) = #PB_DirectoryEntry_Directory
        dir$=DirectoryEntryName(1) 
        If dir$<>"." And dir$<>".."
          json$=MyLoadJSON(minedir$+"\versions\"+dir$)
          ok=#True
          ForEach mines()
            If mines()\dir=dir$
              ok=#False
              Break
            EndIf
          Next
          If ok
            
            AddElement(mines())
            mines()\id=getkey("id",@json$)
            mines()\type=getkey("type",@json$)
            date$=getkey("releaseTime",@json$)
            mines()\time=Date(Val(Mid(date$,1,4)),Val(Mid(date$,6,2)),Val(Mid(date$,9,2)),Val(Mid(date$,11,1)),Val(Mid(date$,15,1)),Val(Mid(date$,18,2)))+Val(Mid(date$,21,2))*60*60
            If mines()\time<Date(2000,1,1,1,1,1)
              date$=getkey("time",@json$)
              d=Date(Val(Mid(date$,1,4)),Val(Mid(date$,6,2)),Val(Mid(date$,9,2)),Val(Mid(date$,11,1)),Val(Mid(date$,15,1)),Val(Mid(date$,18,2)))+Val(Mid(date$,21,2))*60*60
              
              *pos=@mines()
              a$=StringField(mines()\id,1,"-")
              ;debug "search for "+a$
              ForEach mines()
                ;debug mines()\id
                If mines()\id=a$
                  d=mines()\time
                  ;debug "found"
                  Break
                EndIf
              Next              
              ChangeCurrentElement(mines(),*pos)
              mines()\time=d
            EndIf
            
            ;1234567890123456789012345
            ;2014-05-14T19:29:23+02:00
            
            
            
            mines()\dir=dir$
            mines()\downloadable=#False
          EndIf
        EndIf
        
      EndIf
    Wend
    FinishDirectory(1)
  EndIf
  SortStructuredList(mines(),#PB_Sort_Descending ,OffsetOf(mines\time),#PB_Long)
EndProcedure

;------ fenster öffnen
If OpenWindow(0,0,0,900,600,#title+" "+namcl_version+" ("+#bitvers+" Bit)",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Invisible|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget)=#False
  MessageRequester(#title,"Can't open a Window!")
  End
EndIf

;-{ scan program parameters
Repeat
  a$=Trim(UCase(ProgramParameter()))
  If a$=""
    Break
  EndIf
  If Left(a$,2)="--" 
    a$=Right(a$,Len(a$)-2)
  EndIf
  If Left(a$,1)="/" Or Left(a$,1)="-"
    a$=Right(a$,Len(a$)-1)
  EndIf
  
  Select a$
    Case "SELECT"
      PRGPARA_Select$=ProgramParameter()
    Case "SERVER"
      PRGPARA_Server$=ProgramParameter()
    Case "START"
      PRGPARA_Start=#True
    Case "QUIT"
      PRGPARA_QUIT=#True
    Case "VERSION"
      If CreateFile(1,"namcl.ver")
        WriteStringN(1,namcl_version)
        CompilerIf #PB_Compiler_Processor=#PB_Processor_x64
          WriteStringN(1,"64")
        CompilerElseIf #PB_Compiler_Processor=#PB_Processor_x86
          WriteStringN(1,"32")
        CompilerEndIf
        
          
        CloseFile(1)
      EndIf
      End
  EndSelect
    
ForEver 

;}



OpenWinInfo(#title)

;-{ Preferences einlesen


WinInfo2("Read Preferences")
If FileSize("minecraftstart.ini")>0
  OpenPreferences("minecraftstart.ini")
Else
  OpenPreferences(#Title+".ini")
EndIf

namcl_iniversion.s=ReadPreferenceString("naMCl","")
namcl_doupdate=ReadPreferenceLong("naMCl_update",1)
offline=ReadPreferenceLong("Offline-Mode",0)
ForceLogin=ReadPreferenceLong("ForceLogin",1)
StartTab$=ReadPreferenceString("StartTab","News")

curver$= ReadPreferenceString("release","")
cursnap$=ReadPreferenceString("snapshot","")
curprof$=ReadPreferenceString("profile","Current Release")
ShowSnap=ReadPreferenceLong("ShowSnapshot",0)
TwitchToken$=ReadPreferenceString("TwitchToken","")

i=0
Repeat
  If PreferenceGroup("Profile_"+Str(i))=0
    Break
  EndIf
  i+1
  AddElement(profiles())
   
  
  profiles()\title=ReadPreferenceString("titel",curprof$)
  profiles()\minename=ReadPreferenceString("Name","Char"+Random(9999))
  profiles()\ver=ReadPreferenceString("Version","current")
  profiles()\gamedir=ReadPreferenceString("gamedir","<profile>")
  profiles()\prg=ReadPreferenceString("javaw.exe","javaw.exe");"C:\Program Files\Java\jre7\bin\javaw.exe"
  profiles()\doPrgArg=ReadPreferenceLong("dojavaArg",0)
  profiles()\prgarg=ReadPreferenceString("javaArg","-XX:HeapDumpPath=MojangTricksIntelDriversForPerformance_javaw.exe_minecraft.exe.heapdump -Xmx1G -XX:+UseConcMarkSweepGC -XX:+CMSIncrementalMode -XX:-UseAdaptiveSizePolicy -Xmn128M")
  profiles()\password=ReadPreferenceString("password","")
  profiles()\doServerPrgArg=ReadPreferenceLong("doServerArg",0)
  profiles()\Serverprgarg=ReadPreferenceString("ServerArg","-Xmx1024M -Xms1024M")
  
  profiles()\lastlogin=ReadPreferenceString("LastLogin","")
  profiles()\lastminename=ReadPreferenceString("LastName","")
  profiles()\lastuuid=ReadPreferenceString("LastUUID","")
  profiles()\lastusertype=ReadPreferenceString("LastUserType","")
  profiles()\BorderlessWindow=ReadPreferenceLong("BorderlessWindow",0)
  profiles()\server=ReadPreferenceString("Server","")
  profiles()\doServer=ReadPreferenceLong("DoServer",1)
  
  
ForEver
If PreferenceGroup("Web")
  If ExaminePreferenceKeys()
    I=-1
    While i<=#MaxWebCount And NextPreferenceKey()
      i+1
      a$=ReplaceString(PreferenceKeyName(),"_"," ")
      webs(i)\name=a$      
      webs(i)\url=PreferenceKeyValue()
    Wend
  EndIf
Else
  webs(0)\name="News"
  webs(0)\url="http://mcupdate.tumblr.com/"
  
  webs(1)\name="Majong"
  webs(1)\url="https://mojang.com/"
  
  webs(2)\name="Reddit"
  webs(2)\url="http://www.reddit.com/r/Minecraft/.compact"
    
  webs(3)\name="Wiki"
  webs(3)\url="http://minecraft.gamepedia.com/Minecraft_Wiki"
      
  webs(4)\name="Changelog"
  webs(4)\url="http://minecraft.gamepedia.com/index.php?title=Version_history&mobileaction=toggle_view_mobile"
  
  webs(5)\name="Changelog Snapshot"
  webs(5)\url="http://minecraft.gamepedia.com/index.php?title=Version_history/Development_versions&mobileaction=toggle_view_mobile"
  
  webs(6)\name="How to Survive && Thrive"
  webs(6)\url="https://www.youtube.com/playlist?list=PL7326EF82122776A9"
  
  webs(7)\name="Forum"
  webs(7)\url="http://www.minecraftforum.net/forums"
  
  webs(8)\name="Forge"
  webs(8)\url="http://files.minecraftforge.net/"
  
  
EndIf

If PreferenceGroup("Server.properties")
  If ExaminePreferenceKeys()
    While NextPreferenceKey()
      AddElement(ServerOptions())
      ServerOptions()\key=PreferenceKeyName()
      serverOptions()\value=PreferenceKeyValue()
    Wend    
  EndIf
Else
  AddElement(ServerOptions())
  ServerOptions()\key="online-mode"
  serverOptions()\value="false"
  AddElement(ServerOptions())
  ServerOptions()\key="white-list"
  serverOptions()\value="false"
  AddElement(ServerOptions())
  ServerOptions()\key="snooper-enabled"
  serverOptions()\value="false"
EndIf  

ClosePreferences()

If ListSize(profiles())=0
  minename$="Char"+Random(9999)
  AddElement(profiles())
  profiles()\title="Current Release"
  profiles()\minename=minename$
  ;profiles()\ver="current"
  profiles()\gamedir="<profile>"
  profiles()\prg="javaw.exe"
  profiles()\prgarg="-XX:HeapDumpPath=MojangTricksIntelDriversForPerformance_javaw.exe_minecraft.exe.heapdump -Xmx1G -XX:+UseConcMarkSweepGC -XX:+CMSIncrementalMode -XX:-UseAdaptiveSizePolicy -Xmn128M"
  profiles()\Serverprgarg="-Xmx1024M -Xms1024M"
  profiles()\doServer=1
  AddElement(profiles())
  profiles()\title="Current Snapshot"
  profiles()\minename=minename$
  ;profiles()\ver="current_snap"
  profiles()\gamedir="<profile>"
  profiles()\prg="javaw.exe"
  profiles()\prgarg="-XX:HeapDumpPath=MojangTricksIntelDriversForPerformance_javaw.exe_minecraft.exe.heapdump -Xmx1G -XX:+UseConcMarkSweepGC -XX:+CMSIncrementalMode -XX:-UseAdaptiveSizePolicy -Xmn128M"
  profiles()\Serverprgarg="-Xmx1024M -Xms1024M"
  profiles()\doServer=1
EndIf


c=ListSize(profiles())
ForEach profiles()
  ;If profiles()\password
    profiles()\password=DeCrypt(profiles()\minename,profiles()\password,c)
    ;EndIf  
    
    profiles()\lastminename=decrypt(profiles()\lastlogin,profiles()\lastminename,c)
    profiles()\lastuuid=decrypt(profiles()\lastlogin,profiles()\lastuuid,c)
    profiles()\lastusertype=decrypt(profiles()\lastlogin,profiles()\lastusertype,c)
Next
TwitchToken$=decrypt("twitch",TwitchToken$,c)

;}

;-{ naMCl update
If namcl_doupdate
  wininfo2("Check naMCl update")
  ;Debug "check namcl update"
  
  If getfile(#linkupdate,"namclversion.txt",#True,#True)
    in=ReadFile(#PB_Any,"namclversion.txt")
    If in
      a$=LCase(ReadString(in))
      CloseFile(in)
      ;debug "naMCl:"+a$
      
      ;a$="namcl-1.exe"
      b$=LCase("namcl-"+namcl_version+".exe")
      ;debug a$+" "+b$
      a$=StringField(a$,2,"-")
      b$=StringField(b$,2,"-")
      a=Val(StringField(a$,1,"."))*1000000
      a+Val(StringField(a$,2,"."));count
      ;a+Val(StringField(a$,3,"."))*10000;jahr
      ;a+Val(StringField(a$,4,"."))*100;monat
      ;a+Val(StringField(a$,5,"."))*1;tag
      
      b=Val(StringField(b$,1,"."))*1000000
      b+Val(StringField(b$,2,"."));count
      ;b+Val(StringField(b$,3,"."))*100
      ;b+Val(StringField(b$,4,"."))
      ;debug a$+" "+b$
      ;debug Str(a)+" "+Str(b)
      If a>b
        
        If getfile(#linkupdate+"?down","namcl.new")    
          If FileSize("namcl.new")>0
            out=CreateFile(#PB_Any,"doupdate.bat")
            If out 
              prg$=GetFilePart(ProgramFilename())
              WriteStringN(out,"@echo off")
              WriteStringN(out,"if not exist namcl.new goto ende")
              WriteStringN(out,":file")
              WriteStringN(out,"del "+Chr(34)+prg$+Chr(34))
              WriteStringN(out,"if exist "+Chr(34)+prg$+Chr(34)+" goto file")
              WriteStringN(out,"ren namcl.new "+Chr(34)+prg$+Chr(34))
              WriteStringN(out,":ende")
              WriteStringN(out,"start "+Chr(34)+"naMCl"+Chr(34)+" "+Chr(34)+prg$+Chr(34))
              CloseFile(out)
              RunProgram("doupdate.bat")
              End
              
            EndIf
          EndIf
          
        EndIf
      EndIf
    EndIf
    DeleteFile("namclversion.txt")
  EndIf
EndIf
;}

;-{ Versions.json downloaden und auswerten.
WinInfo2("Check for Minecraft updates")
CreateDirectory(minedir$)
CreateDirectory(minedir$+"\versions")
If ReceiveHTTPFile("http://s3.amazonaws.com/Minecraft.Download/versions/versions.json",minedir$+"\versions\versions.json")
  json$=MyLoadJSON(minedir$+"\versions\versions.json")
  
  a$=GetKey("latest",@json$)
  curver$= GetKey("release",@a$)
  cursnap$=getkey("snapshot",@a$)
  
  jver$=GetKey("versions",@json$)
  
  i=0
  
  Repeat
    a$=SplitJson(@jver$,i)
    If a$=""
      Break;
    EndIf
    type$=getkey("type",@a$)
    If type$="snapshot" And ShowSnap=#False
      ;Debug "snapfilter"
    Else
      AddElement(mines())
      mines()\id=GetKey("id",@a$)
      mines()\type=GetKey("type",@a$)
      date$=GetKey("releaseTime",@a$)
      mines()\time=Date(Val(Mid(date$,1,4)),Val(Mid(date$,6,2)),Val(Mid(date$,9,2)),Val(Mid(date$,11,1)),Val(Mid(date$,15,1)),Val(Mid(date$,18,2)))+Val(Mid(date$,21,2))*60*60
      mines()\dir=mines()\id
      mines()\downloadable=#True
    EndIf
  
    i+1
  ForEver
  
  
  
EndIf  
AddElement(mines())
mines()\id=curver$
mines()\type="release"
mines()\time=Date()
mines()\dir="current"
mines()\downloadable=#True
AddElement(mines())
mines()\id=cursnap$
mines()\type="snapshot"
mines()\time=Date()-1000
mines()\dir="current_snap"
mines()\downloadable=#True

;}


;-{ vorhandene Installationen
WinInfo2("Scan installed Versions")

Scan_mines()

;}



;-{ Fenster erstellen
WinInfo2("Build UI")
UseGadgetList(WindowID(0))
SmartWindowRefresh(0, #True ) 
WindowBounds(0,900,600,#PB_Default,#PB_Default)

settinghight=20+5+20+5+20+5+20+5

PanelGadget(#gPnl_Settings,0,WindowHeight(0)-settinghight-25-50,405,settinghight)
AddGadgetItem(#gPNL_Settings,-1,"MineCraft")
y=0
TextGadgetV(#gTXT_Name,  0,y,  100,20,"Name")
StringGadget(#gSTR_Name,  100,y, 300,20,"")
y+25
TextGadgetV(#gTXT_Password,  0,y,  100,20,"Password")
StringGadget(#gSTR_Password, 100,y, 300,20,"",#PB_String_Password)
y+25  
TextGadgetV(#gTXT_Version,  0,y,  100,20,"Minecraft Version")
ComboBoxGadget(#gCBX_Version,  100,y,  300,20)
y+25
TextGadgetV(#gTXT_Dir,  0,y,  100,20,"Game Directory")
ComboBoxGadget(#gCBX_Dir, 100,y, 300,20, #PB_ComboBox_Editable)

  HiddenStringGadget(#gHST_lastlogin)
  HiddenStringGadget(#gHST_lastminename)
  HiddenStringGadget(#gHST_lastuuid)
  HiddenStringGadget(#gHST_lastusertype)
  
  


AddGadgetItem(#gPNL_Settings,-1,"Java")
y=0
TextGadgetV(#gTXT_JavaExe,  0,y,  100,20,"Java.exe")
StringGadget(#gSTR_JavaExe, 100,y, 300,20,"")
y+25
CheckBoxGadget(#gCHK_JavaArg,  0,y,  100,20,"Options")
StringGadget(#gSTR_JavaArg, 100,y, 300,20,"")
y+25
CheckBoxGadget(#gCHK_ServerPRGArg,  0,y,  100,20,"Server-Options")
StringGadget(#gSTR_ServerPRGArg, 100,y, 300,20,"")
y+25

AddGadgetItem(#gPNL_Settings,-1,"Additional")
y=0
CheckBoxGadget(#gCHK_BorderlessWindow,  0,y,  400,20,"Borderless Window")
y+25
CheckBoxGadget(#gCHK_ServerIP,  0,y,  100,20,"Auto-Connect to")
StringGadget(#gSTR_ServerIp, 100,y, 300,20,"")
y+25


AddGadgetItem(#gPNL_Settings,-1,"naMCl")
y=0
CheckBoxGadget(#gCHK_namclupdate,  0,y,  200,20,"do naMCl update")
CheckBoxGadget(#gCHK_offline,  200,y,  200,20,"Offline mode")
y+25
CheckBoxGadget(#gCHK_ForceLogin,  0,y,  200,20,"Force Login")
CheckBoxGadget(#gCHK_ShowSnap,  200,y,  200,20,"Show Snapshots (restart)")
y+25
CheckBoxGadget(#gCHK_authorizeTwitch,0,y,200,20,"Authorize Twitch")
y+25
TextGadgetV(#gTXT_StartTab,  0,y,  100,20,"Start Tab")
ComboBoxGadget(#gCBX_StartTab,  100,y,  300,20)
y+25



HiddenStringGadget(#gHST_TwitchToken,TwitchToken$)
If TwitchToken$
  SetGadgetState(#gCHK_authorizeTwitch,#True)
EndIf




SetGadgetState(#gCHK_namclupdate,namcl_doupdate)
SetGadgetState(#gCHK_offline,offline)
SetGadgetState(#gCHK_ForceLogin,ForceLogin)
SetGadgetState(#gCHK_ShowSnap,ShowSnap)

;TextGadget(#gTXT_UUID,  5,y,  100,20,"UUID")
;StringGadget(#gSTR_UUID, 110,y, 300,20,"",#PB_String_Password)
CloseGadgetList()

ButtonGadget(#gBTN_Start,  5,WindowHeight(0)-45,405,40,"START", #PB_Button_Default)

ListViewGadget(#gLST_Profile,415,5,WindowWidth(0)-415-5,GadgetHeight(#gPNL_Settings))


WebGadget(#gWeb_Twitch,5,5,100,100,"about:blank")
HideGadget(#gWeb_Twitch,#True)
MyWebGadget.IWebBrowser2=GetWindowLong_(GadgetID(#gWeb_Twitch),#GWL_USERDATA)
MyWebGadget\put_Silent(#True) ; Suppress JavaScript error messages.



PanelGadget(#gPNL_NewsDir,5,5,WindowWidth(0)-10,GadgetY(#gPNL_Settings)-5)

If offline=#False
  For i=0 To #MaxWebCount
    If webs(i)\url<>""
      addweb(#gweb_start+i,webs(I)\name,webs(i)\url)
     
    EndIf    
  Next
EndIf

AddGadgetItem(#gPNL_NewsDir,-1,"Screenshots")
;Imgw=(GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemWidth)-20)/4
;Imgh=GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemHeight)/3
panelScreens=CountGadgetItems(#gPNL_NewsDir)-1
CreateImage(#img_blank,imgw,imgh-20,24,RGB(255,255,255))
;For y=0 To 2 
;  For x=0 To 3 
;    ContainerGadget(#gcon_picstart+y*4+x,x*imgw,y*imgh,imgw,imgh,#PB_Container_BorderLess)
;    ImageGadget(#gPIC_picstart+y*4+x,0,0,imgw,imgh-20,ImageID(#img_blank))
;    TextGadget(#gTXT_picstart+y*4+x,0,imgh-20,imgw,20,"", #PB_Text_Center)
;    CloseGadgetList()
;  Next
;Next
ScrollBarGadget(#gSCR_pic,GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemWidth)-21,0,20,GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemHeight),0,0,1,#PB_ScrollBar_Vertical)


AddGadgetItem(#gPNL_NewsDir,-1,"Directory")
ButtonGadget(#gBTN_Gamedir,0,0,GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemWidth),20,"")
ListIconGadget(#gLST_Save,0,20,GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemWidth),GetGadgetAttribute(#gPNL_NewsDir,#PB_Panel_ItemHeight)-20,"World",250,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
AddGadgetColumn(#gLST_Save, 1, "Difficulty", #LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Save, 2, "Gamemode", #LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Save, 3, "Cheat", #LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Save, 4, "Invulnerable", #LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Save, 5, "Generator", #LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Save, 6, "Seed", #LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Save, 7, "Last Played", #LVSCW_AUTOSIZE)
EnableGadgetDrop(#glst_save, #PB_Drop_Files,#PB_Drag_Copy|#PB_Drag_Move)

ListIconGadget(#gLST_Resourcepack,100,100,100,100,"Resource Pack",250,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
AddGadgetColumn(#gLST_Resourcepack,1,"Description",#LVSCW_AUTOSIZE)
ListIconGadget(#glst_Shaderpack,100,100,100,100,"Shader Pack",250,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
AddGadgetColumn(#glst_Shaderpack,1,"Description",#LVSCW_AUTOSIZE)
ListIconGadget(#gLST_Mods,100,100,100,100,"Mods",250,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
AddGadgetColumn(#gLST_Mods,1,"Version",#LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Mods,2,"MC",#LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_Mods,3,"Description",#LVSCW_AUTOSIZE)
ListIconGadget(#gLST_ModsServer,100,100,100,100,"Server-Mods",250,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
AddGadgetColumn(#gLST_ModsServer,1,"Version",#LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_ModsServer,2,"MC",#LVSCW_AUTOSIZE)
AddGadgetColumn(#gLST_ModsServer,3,"Description",#LVSCW_AUTOSIZE)


AddGadgetItem(#gPNL_NewsDir,-1,"Servers")
PanelServers=CountGadgetItems(#gPNL_NewsDir)-1
ListIconGadget(#gLST_Servers,0,0,100,100,"Name",100,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
AddGadgetColumn(#gLst_Servers,1,"IP",100)
AddGadgetColumn(#gLst_Servers,2,"Version",100)
AddGadgetColumn(#gLst_Servers,3,"Players",100)
AddGadgetColumn(#gLST_Servers,4,"Ping",100)
AddGadgetColumn(#gLST_Servers,5,"Description",100)

CloseGadgetList()

c=CountGadgetItems(#gPNL_NewsDir)-1
For i=0 To c
  a$=GetGadgetItemText(#gPNL_NewsDir,i)
  AddGadgetItem(#gCBX_StartTab,i,a$)
  If a$=StartTab$
    SetGadgetState(#gPNL_NewsDir,i)
    SetGadgetState(#gCBX_StartTab,i)
  EndIf  
Next



;SetGadgetItemText(#gDIR_Textures,-1,"Texturepacks",0)
;SetGadgetItemText(#gDIR_Mods,-1,"Mods",0)
;RemoveGadgetColumn(#gDIR_Textures,1)
;RemoveGadgetColumn(#gDIR_Textures,1)
;RemoveGadgetColumn(#gDIR_Textures,1)
;RemoveGadgetColumn(#gDIR_Mods,1)
;RemoveGadgetColumn(#gDIR_Mods,1)
;RemoveGadgetColumn(#gDIR_Mods,1)




CreatePopupMenu(#m_Profile)
MenuItem(#m_Profile_New,"New")
MenuItem(#m_Profile_Rename,"Rename")
OpenSubMenu("Delete")
MenuItem(#m_Profile_Delete,"Confirm")
CloseSubMenu() 

CreatePopupMenu(#m_Screen)
OpenSubMenu("Delete")
MenuItem(#m_Screen_Delete,"Confirm")
CloseSubMenu() 

CreatePopupMenu(#m_respack)
OpenSubMenu("Delete")
MenuItem(#m_respack_delete,"Confirm")
CloseSubMenu() 

CreatePopupMenu(#m_shaderpack)
OpenSubMenu("Delete")
MenuItem(#m_shaderpack_delete,"Confirm")
CloseSubMenu() 

CreatePopupMenu(#m_mods)
OpenSubMenu("Delete")
MenuItem(#m_mods_delete,"Confirm")
CloseSubMenu() 
MenuItem(#m_mods_homepage,"Visit Homepage")
CreatePopupMenu(#m_modsServer)
OpenSubMenu("Delete")
MenuItem(#m_modsServer_delete,"Confirm")
CloseSubMenu() 
MenuItem(#m_modsServer_homepage,"Visit Homepage")

CreatePopupMenu( #m_saves)
MenuItem(#m_saves_copyseed,"Copy Seed")
OpenSubMenu("Difficulty")
MenuItem(#m_saves_diff0,"Peaceful")
MenuItem(#m_saves_diff1,"Easy")
MenuItem(#m_saves_diff2,"Normal")
MenuItem(#m_saves_diff3,"Hard")
MenuItem(#m_saves_lock_diff,"Lock Difficulty")
MenuItem(#m_saves_lock_hard,"Lock Hardcore")
CloseSubMenu()
OpenSubMenu("Game mode")
MenuItem(#m_saves_mode_s,"Survival")
MenuItem(#m_saves_mode_c,"Creative")
MenuItem(#m_saves_mode_a,"Adventure")
CloseSubMenu()
;OpenSubMenu("Life")
MenuItem(#m_saves_Invulnerable,"Invulnerable")
MenuItem(#m_saves_Cheat,"Cheats")
MenuBar()
OpenSubMenu("Delete")
MenuItem(#m_saves_Delete,"Confirm")
CloseSubMenu() 
MenuItem(#m_saves_clone,"Clone")
MenuItem(#m_saves_backup,"Export ZIP")
;MenuItem(#m_saves_vulnerable,"Vulnerable")
CloseSubMenu()
MenuBar()
MenuItem(#m_saves_startasserver,"Start as Server")

CreatePopupMenu(#m_server)
MenuItem(#m_server_start,"Connect to Server")
MenuItem(#m_server_set_autoconnect,"Set as auto-connect")


AddGadgetItem(#gCBX_Dir,-1,"Global")
AddGadgetItem(#gCBX_Dir,-1,"<profile>")
AddGadgetItem(#gCBX_Dir,-1,"<version>")
AddGadgetItem(#gCBX_Dir,-1,"<type>")
AddGadgetItem(#gCBX_Dir,-1,"<type>\<version>")
If ExamineDirectory(0,minedir$+"\gamedir\","")
  While NextDirectoryEntry(0)
    If DirectoryEntryType(0)=#PB_DirectoryEntry_Directory
      n$=DirectoryEntryName(0)
      If n$<>"." And n$<>".." And n$<>"Global"
        AddGadgetItem(#gCBX_Dir,-1,n$)
      EndIf
    EndIf
  Wend
EndIf


Build_Mines()
build_profiles(curprof$)

EnableGadgetDrop(#gLST_Profile,#PB_Drop_Private,#PB_Drag_Move,1)
EnableGadgetDrop(#gLST_Resourcepack,#PB_Drop_Files,#PB_Drag_Copy)
EnableGadgetDrop(#glst_mods,#PB_Drop_Files,#PB_Drag_Copy)
EnableGadgetDrop(#gLST_ModsServer,#PB_Drop_Files,#PB_Drag_Copy)
EnableGadgetDrop(#glst_Shaderpack,#PB_Drop_Files,#PB_Drag_Copy)

resize_win0()
HideWindow(0,#False)
CloseWinInfo()
SetWindowCallback(@MyWindowCallback())


;AddKeyboardShortcut(0,#PB_Shortcut_Return,#m_start)
AddKeyboardShortcut(0,#PB_Shortcut_Escape,#m_end)


If PRGPARA_Select$
  c=CountGadgetItems(#gLST_Profile)-1
  For x=0 To c
    If GetGadgetItemText(#gLST_Profile,x)=PRGPARA_Select$
      If lastprof<>x
        StoreProfile(lastprof)
        DisplayProfile(x)
      EndIf
      Break
    EndIf
  Next
EndIf

If PRGPARA_Server$ Or PRGPARA_start
  StartMinecraft(PRGPARA_Server$)
EndIf     

;------------------- hauptschleife
Repeat
  If PRGPARA_QUIT
    Break
  EndIf
  
  
  
  event=WaitWindowEvent()
  Select event
    Case #PB_Event_SizeWindow
      resize_win0(#True)
      
      
    Case #PB_Event_CloseWindow
      Break
    Case #PB_Event_Menu;- event_menu
      Select EventMenu()
        Case #m_start:StartMinecraft()
        Case #m_end:Break
          
        Case #m_server_start;-{ server start
          ip$=GetGadgetItemText(#gLST_Servers,last_selected_server,1)
          StartMinecraft(ip$)
          ;}
        Case #m_server_set_autoconnect;-{ server set_autoconnect
          ip$=GetGadgetItemText(#gLST_Servers,last_selected_server,1)
          SetGadgetText(#gSTR_ServerIP,ip$)
          ;}
          
          
          
        Case #m_Profile_New;-{ new profile
          a$=InputRequester("Minecraft Starter","Neues Profil","")
          If a$
            do=#True
            ForEach profiles()
              If profiles()\title=a$
                do=#False
              EndIf
            Next
            If do
              StoreProfile(lastprof)
              LastElement(profiles())
              AddElement(profiles())
              profiles()\title=a$
              
              AddGadgetItem(#gLST_Profile,-1,a$)
              lastprof=ListSize(profiles())-1
            EndIf
            
          EndIf
          DisplayProfile(lastprof)
          ;}
          
        Case #m_Profile_Rename;-{ rename profile
          SelectElement(profiles(),lastprof)
          a$=InputRequester("Minecraft Starter","Profil "+profiles()\title+" umbenennen",profiles()\title)
          If a$
            do=#True
            ForEach profiles()
              If profiles()\title=a$
                do=#False
              EndIf
            Next
            If do
              StoreProfile(lastprof)
              profiles()\title=a$
              SetGadgetItemText(#gLST_Profile,lastprof,a$)
            EndIf
            
          EndIf
          DisplayProfile(lastprof)
          ;}
                    
        Case #m_Profile_Delete;-{ delete profile
          If lastprof>1
            SelectElement(profiles(),lastprof)
            DeleteElement(profiles())
            RemoveGadgetItem(#gLST_Profile,lastprof)
            lastprof-1
            DisplayProfile(lastprof)
            SetGadgetState(#gLST_Profile,lastprof)
          EndIf
          ;}
          
        Case #m_Screen_Delete;-{ delete screen
          a$=GetGadgetText(#gBTN_Gamedir)+"/screenshots/"
          ForEach SelectedPic()
            If selectedpic()=1
              DeleteFile( a$+MapKey(selectedpic()))
            EndIf              
          Next
          ClearMap(SelectedPic())
          LoadScreenshots(GetGadgetState(#gSCR_pic))
          ;}
          
        Case #m_respack_delete;-{ delete respack
          SelectElement(ResourcePack(),last_selected_respack)
          DeleteFile( ResourcePack()\file)
          Load_ResourcePack(#True)
          ;}
        Case #m_shaderpack_delete;-{ delete shaderpack
          SelectElement(ShaderPack(),last_selected_shaderpack)
          DeleteFile( ShaderPack()\file)
          Load_ShaderPack(#True)
          ;}
          
        Case #m_mods_delete;-{ delete mods
          SelectElement(Mods(),last_selected_mods)
          DeleteFile( Mods()\file)
          Load_Mods(#True)
        Case #m_modsserver_delete
          SelectElement(ModsServer(),last_selected_modsserver)
          DeleteFile( ModsServer()\file)
          Load_Mods(#True)
          ;}
          
        Case #m_mods_homepage;-{ homepage mods
          SelectElement(Mods(),last_selected_mods)
          RunProgram(mods()\url)
        Case #m_modsServer_homepage
          SelectElement(ModsServer(),last_selected_modsserver)
          RunProgram(ModsServer()\url)
          ;}
          
        Case #m_saves_delete;-{ saves delete
          SelectElement(saves(),last_selected_save)
          DeleteDirectory(GetGadgetText(#gBTN_Gamedir)+"\saves\"+saves()\dir,"",#PB_FileSystem_Recursive|#PB_FileSystem_Force)
          LoadSaves(#True)
          ;}
          
        Case #m_saves_clone;-{ saves clone
          SelectElement(saves(),last_selected_save)
          dir$=GetGadgetText(#gBTN_Gamedir)+"\saves\"
          sub$=saves()\dir  
          c=2
          While FileSize(dir$+sub$+"("+Str(c)+")")=-2
            c+1
          Wend
          sub$+"("+Str(c)+")"
          CopyDirectory(dir$+saves()\dir,dir$+sub$,"",#PB_FileSystem_Recursive)
          loadsaves(#True)
          ;}
          
        Case #m_saves_backup;-{ saves backup
          SelectElement(saves(),last_selected_save)
          file$=SaveFileRequester("MineStartet - Export "+saves()\levelname,
                                  saves()\levelname+" "+FormatDate("%yyyy%mm%dd%hh%ii",saves()\lastplayed/1000)+".zip",
                                  "Zip|*.zip|*|*.*",
                                  0)
          
          If file$
            saves_backup(GetGadgetText(#gBTN_Gamedir)+"\saves\",saves()\dir,file$)
          EndIf
          ;}
          
        Case #m_saves_startasserver ;-{ saves server
          SavesAsServer(last_selected_save)                     
          ;}
                        
        Case #m_saves_copyseed;-{ saves copy seed
          SelectElement(saves(),last_selected_save)
          SetClipboardText(StrU(saves()\randomseed))
          ;}
          
        Case #m_saves_firstpatch To #m_saves_lastpatch;-{ patch saves
          dir$=GetGadgetText(#gBTN_Gamedir)+"\saves\"
          SelectElement(saves(),last_selected_save)
          If FileSize(dir$+saves()\dir+"\level.bak")<0
            CopyFile(dir$+saves()\dir+"\level.dat",dir$+saves()\dir+"\level.bak")
          EndIf
          
          If loadntb(dir$+saves()\dir+"\level.dat")
            Select EventMenu()
              Case #m_saves_cheat
                saves()\allowcommands!1
                NTB_setValue("\Data\allowCommands",saves()\allowcommands)
              Case #m_saves_Invulnerable
                saves()\invulnerable!1
                NTB_setValue("\Data\Player\Invulnerable",saves()\invulnerable)
              Case #m_saves_diff0 To #m_saves_diff3
                saves()\difficulty=EventMenu()-#m_saves_diff0
                ntb_setvalue("\Data\Difficulty",saves()\difficulty)
              Case #m_saves_lock_diff
                saves()\difficultylocked!1
                ntb_setvalue("\Data\DifficultyLocked",saves()\difficultylocked)
              Case #m_saves_lock_hard
                saves()\hardcore!1
                ntb_setvalue("\Data\hardcore",saves()\hardcore)
              Case #m_saves_mode_s To #m_saves_mode_a
                saves()\gametype=EventMenu()-#m_saves_mode_s
                ntb_setvalue("\Data\GameType",saves()\gametype)
                NTB_SetValue("\Data\Player\playerGameType",saves()\gametype)
            EndSelect
            
            
            
            saventb(dir$+saves()\dir+"\level.dat")
            LoadSaves()
          EndIf
          ;}
          
      EndSelect    
    Case #PB_Event_GadgetDrop;- event_drop
      g=EventGadget()
      If EventDropType()=#PB_Drop_Files
      
        Files$ = EventDropFiles()
        Count  = CountString(Files$, Chr(10)) + 1
      Else
        files$=""
        count=0
      EndIf
      
      dropevent=EventDropAction()
      Select g
        Case #gLST_Resourcepack,#gLST_Mods,#gLST_ModsServer,#glst_Shaderpack;-{ resourcepack, mods, shaderpacks
          If g=#gLST_Resourcepack
            dir$=GetGadgetText(#gBTN_Gamedir)+"\resourcepacks\"
          ElseIf g=#gLST_Mods
            dir$=GetGadgetText(#gBTN_Gamedir)+"\mods\"
          ElseIf g=#gLST_ModsServer
            dir$=GetGadgetText(#gBTN_Gamedir)+"\saves\mods\"
          ElseIf g=#glst_Shaderpack
            dir$=GetGadgetText(#gBTN_Gamedir)+"\shaderpacks\"
          EndIf
          
          ForceDirectories(dir$)
          
          OpenWinInfo("Copy files")
          For i=1 To count
            file$=StringField(files$,i,Chr(10))
            name$=GetFilePart(file$)
            If FileSize(dir$+name$)<>-1
              i=0
              e$=GetExtensionPart(name$)
              b$=Left(name$,Len(name$)-Len(e$)-1)
              Repeat
                name$=b$+"_"+Str(i)+"."+e$:i+1
                ;debug name$
              Until FileSize(dir$+name$)=-1
            EndIf
            wininfo1(name$)
            
            CopyFile(file$,dir$+name$)
          Next
          CloseWinInfo()
          
          Load_ResourcePack(#True)
          Load_Mods(#True)
          Load_ShaderPack(#True)
          ;}
          
            
        Case #gLST_Profile;-{ profile
                          ;debug "von "+Str(lastprof)+" nach "+GetGadgetState(#gLST_Profile)
          newpos=GetGadgetState(#gLST_Profile)
          curprof$=profiles()\title
          If (newpos>1 Or newpos=-1) And newpos<>lastprof
            SelectElement(profiles(),lastprof)
            *p1=@profiles()
            
            If newpos=-1
              LastElement(profiles())
              AddElement(profiles())
            Else
              SelectElement(profiles(),newpos)
              InsertElement(profiles())
            EndIf
            
            *p2=@profiles()
            SwapElements(profiles(),*p1,*p2)
            ChangeCurrentElement(profiles(),*p2)
            DeleteElement(profiles())
           
          EndIf

          
          Build_Profiles(curprof$)
          ;}
          
        Case #gLST_Save;-{ saves
          dir$=GetGadgetText(#gBTN_Gamedir)+"\saves\"
          OpenWinInfo("Scan")
          For i=1 To count
            sourcedir$=""
            infile$=StringField(files$,i,Chr(10))
            If LCase(Left(infile$,Len(dir$)))=LCase(dir$)
              ;debug "selbstablage!"
              Break
            EndIf
            
            wininfo1(infile$)
            wininfob(i*100/count)
            
            If FileSize(infile$)=-2
              If FileSize(infile$+"\level.dat")>0
                sourcedir$=infile$
              EndIf
            ElseIf LCase(GetFilePart(infile$))="level.dat"
              sourcedir$=GetPathPart(infile$)
              sourcedir$=Left(sourcedir$,Len(sourcedir$)-1)
            ElseIf LCase(GetExtensionPart(infile$))="zip"
              
              ;{
              
              
              Structure pck_leveldat
                startdir.s
                sub.s
              EndStructure
              NewList pck_leveldat.pck_leveldat()
              
              ClearList(pck_leveldat())
              
              If OpenPack(1,infile$)
                If ExaminePack(1)
                  startdir$=""
                  wininfo2("Scan Zip")
                  While NextPackEntry(1)
                    If PackEntryType(1)=#PB_Packer_File
                      n$=PackEntryName(1)
                      If LCase(GetFilePart(n$))="level.dat"
                        
                        temp$=GetTemporaryDirectory()+"minestarter_level_dat_"+StrU(Date())
                        UncompressPackFile(1,temp$)
                        If loadntb(temp$)
                          AddElement(pck_leveldat())
                          pck_leveldat()\startdir=GetPathPart(n$)
                          pck_leveldat()\sub=NTB_GetValueS("\Data\LevelName")
                          
                          freentb()
                          
                          
                        EndIf
                        
                        DeleteFile(temp$)
                        
                      EndIf
                      
                    EndIf
                  Wend
                  ForEach pck_leveldat()
                    startdir$=pck_leveldat()\startdir
                    sub$=pck_leveldat()\sub
                    
                    If FileSize(dir$+sub$)=-2
                      c=2
                      While FileSize(dir$+sub$+"("+Str(c)+")")=-2
                        c+1
                      Wend
                      sub$+"("+Str(c)+")"
                    EndIf
                    
                    wininfo2("Add World "+sub$)
                    saves_createstruc(dir$+sub$+"\")
                    ExaminePack(1)
                    While NextPackEntry(1)
                      If PackEntryType(1)=#PB_Packer_File
                        n$=PackEntryName(1)
                        If Left(n$,Len(startdir$))=startdir$
                          f$=ReplaceString(Right(n$,Len(n$)-Len(startdir$)),"/","\")
                          ForceDirectories(GetPathPart(dir$+sub$+"\"+f$))
                          UncompressPackFile(1,dir$+sub$+"\"+f$)
                        EndIf
                      EndIf
                    Wend
                  Next
                EndIf
                
                ClearList(pck_leveldat())
                ClosePack(1)
              EndIf
              ;}
              
            EndIf
            If sourcedir$
              If loadntb(sourcedir$+"\level.dat")
                sub$=NTB_GetValueS("\Data\LevelName")
                freentb()
                If FileSize(dir$+sub$)=-2
                  c=2
                  While FileSize(dir$+sub$+"("+Str(c)+")")=-2
                    c+1
                  Wend
                  sub$+"("+Str(c)+")"
                EndIf
                wininfo2("Add World "+sub$)
                
                Select dropevent
                  Case #PB_Drag_Copy                      
                    CopyDirectory(sourcedir$,dir$+sub$,"",#PB_FileSystem_Recursive)
                  Case #PB_Drag_Move
                    RenameFile(sourcedir$,dir$+sub$)
                EndSelect
                
              EndIf
            EndIf      
          Next
          LoadSaves(#True)
          CloseWinInfo()
          ;}
          
      EndSelect
    Case #WM_MOUSEWHEEL;- wm_mousewheel
      If GetGadgetState(#gPNL_NewsDir)=panelScreens
        p=GetGadgetState(#gSCR_pic)
        If EventwParam()<0
          p+1
        Else
          p-1
        EndIf
        min=GetGadgetAttribute(#gSCR_pic,#PB_ScrollBar_Minimum)
        If p<min:p=min:EndIf
        max=GetGadgetAttribute(#gSCR_pic,#PB_ScrollBar_Maximum)
        If p>max:p=max:EndIf
        LoadScreenshots(p)
      EndIf
      
      
    Case #PB_Event_Gadget;- event_gadget
      Select EventGadget();-{ twitch
        Case #gCHK_authorizeTwitch
          If show_twitchautorize
            HideGadget(#gPNL_NewsDir,#False)
            HideGadget(#gWeb_Twitch,#True)
            SetGadgetText(#gWeb_Twitch,"about:blank")
            show_twitchautorize=#False
          Else
            SetGadgetText(#gHST_TwitchToken,"")
            SetGadgetState(#gCHK_authorizeTwitch,#False)
            HideGadget(#gPNL_NewsDir,#True)
            HideGadget(#gWeb_Twitch,#False)
            SetGadgetText(#gWeb_Twitch,#Twitch_URL)
            show_twitchautorize=#True
          EndIf
        Case #gWeb_Twitch
          Select EventType()
            Case #PB_EventType_DownloadEnd,#PB_EventType_DownloadEnd
              If show_twitchautorize=#True
                a$=GetGadgetText(#gWeb_Twitch)
                a=FindString(a$,"access_token=")
                If a 
                  b=FindString(a$,"&",a)
                  token$=Mid(a$,a+13,b-a-13)
                  Debug "seite:"+a$
                  Debug "twitch token:"+token$
                  SetGadgetText(#gHST_TwitchToken,token$)
                  SetGadgetState(#gCHK_authorizeTwitch,#True)
                  SetGadgetText(#gWeb_Twitch,"about:blank")
                  HideGadget(#gPNL_NewsDir,#False)
                  HideGadget(#gWeb_Twitch,#True)      
                  show_twitchautorize=#False
                EndIf
              EndIf
          EndSelect
          
          ;}
          
          ;-{ namcl settings
        Case #gCHK_namclupdate
          namcl_doupdate=GetGadgetState(#gCHK_namclupdate)
        Case #gCHK_offline
          offline=GetGadgetState(#gCHK_offline)
        Case #gCHK_ForceLogin
          ForceLogin=GetGadgetState(#gCHK_ForceLogin)
        Case #gCHK_ShowSnap
          ShowSnap=GetGadgetState(#gCHK_ShowSnap)
        Case #gCBX_StartTab
          StartTab$=GetGadgetText(#gCBX_StartTab)
          ;}
          
        Case #gLST_Servers;-{ serverlist
          Select EventType()
            Case #PB_EventType_RightClick
              last_selected_server=GetGadgetState(#gLST_Servers)
              DisplayPopupMenu(#m_server,WindowID(0))
              
            Case #PB_EventType_LeftDoubleClick
              i=GetGadgetState(#gLST_Servers)
              ip$=GetGadgetItemText(#glst_servers,i,1)
              StartMinecraft(ip$)
          EndSelect
          
          ;}
          
        Case #gPNL_NewsDir;-{ panel newsdir
          x=GetGadgetState(#gPNL_NewsDir)
          ForEach web()
            If web()\panel=x
              SetActiveGadget(web()\gadget-#gWeb_Start+#gWeb_URL)
              ;debug "found:"+web()\home
            EndIf            
          Next
          ;}
          
        Case #gWeb_back To #gweb_backend;{ web back
          SetGadgetState(EventGadget()-#gweb_back+#gWeb_Start,#PB_Web_Back)
          ;}
          
        Case #gWeb_home To #gWeb_homeend;-{ web home
          x=GetGadgetState(#gPNL_NewsDir)
          ForEach web()
            If web()\panel=x
              SetGadgetText(web()\gadget,web()\home)
            EndIf            
          Next
          ;}
          
        Case #gLST_Mods;-{ mods
          Select EventType()
            Case #PB_EventType_RightClick
              g=GetGadgetState(#gLST_Mods)
              If g>=0
                SelectElement(mods(),g)
                DisableMenuItem(#m_mods,#m_mods_homepage,Bool(mods()\url=""))
                last_selected_mods=g
                DisplayPopupMenu(#m_mods,WindowID(0))
              EndIf
          EndSelect
        Case #gLST_ModsServer
          Select EventType()
            Case #PB_EventType_RightClick
              g=GetGadgetState(#gLST_ModsServer)
              If g>=0
                SelectElement(ModsServer(),g)
                DisableMenuItem(#m_modsServer,#m_modsserver_homepage,Bool(ModsServer()\url=""))
                last_selected_modsserver=g
                DisplayPopupMenu(#m_modsServer,WindowID(0))
              EndIf
          EndSelect
          
          ;}
          
        Case #gLST_Resourcepack;-{ resource pack
          Select EventType()
            Case #PB_EventType_RightClick
              g=GetGadgetState(#gLST_Resourcepack)
              If g>=0
                SelectElement(ResourcePack(),g)
                last_selected_respack=g
                DisplayPopupMenu(#m_respack,WindowID(0))
              EndIf
          EndSelect
          ;}
        Case #glst_Shaderpack;-{ shader pack
          Select EventType()
            Case #PB_EventType_RightClick
              g=GetGadgetState(#glst_Shaderpack)
              If g>=0
                SelectElement(ShaderPack(),g)
                last_selected_shaderpack=g
                DisplayPopupMenu(#m_shaderpack,WindowID(0))
              EndIf
          EndSelect
          ;}
              
          
        Case #gLST_Save;-{ saves
          Select EventType()
            Case #PB_EventType_DragStart
              g=GetGadgetState(#gLST_Save)
              If g>=0
                SelectElement(saves(),g)
                DragFiles(GetGadgetText(#gBTN_Gamedir)+"\saves\"+saves()\dir,#PB_Drag_Copy|#PB_Drag_Move)
                loadsaves(#True)
              EndIf
              
              
              
            Case #PB_EventType_RightClick
              g=GetGadgetState(#gLST_Save)
              If g>=0
                SelectElement(saves(),g)                    
                DisableMenuItem(#m_saves,#m_saves_lock_hard,1-saves()\hashardcore)
                DisableMenuItem(#m_saves,#m_saves_lock_diff,1-saves()\hasdifficultylock)
                SetMenuItemState(#m_saves,#m_saves_lock_hard,saves()\hardcore)
                SetMenuItemState(#m_saves,#m_saves_lock_diff,saves()\difficultylocked)
                For i=0 To 3
                  DisableMenuItem(#m_saves,#m_saves_diff0+i,Bool(saves()\difficulty=-1))
                  SetMenuItemState(#m_saves,#m_saves_diff0+i,0)
                Next
                For i=0 To 2
                  SetMenuItemState(#m_saves,#m_saves_mode_s+i,0)
                Next
                If saves()\difficulty>=0
                  SetMenuItemState(#m_saves,#m_saves_diff0+saves()\difficulty,1)
                EndIf
                SetMenuItemState(#m_saves,#m_saves_mode_s+saves()\gametype,1)
                SetMenuItemState(#m_saves,#m_saves_Invulnerable,saves()\invulnerable)
                SetMenuItemState(#m_saves,#m_saves_Cheat,saves()\allowcommands)
                last_selected_save=g
                DisplayPopupMenu(#m_saves,WindowID(0))
              EndIf              
              
          EndSelect
          ;}
          
        Case #gPIC_picstart To #gPIC_picend ;-{ pics
          nr=EventGadget()
          If nr=>#gPIC_picstart And nr<=#gPIC_picend
            nr-#gpic_picstart
          ElseIf nr=>#gtxt_picstart And nr<=#gtxt_picend
            nr-#gtxt_picstart
          ElseIf nr>=#gcon_picstart And nr<=#gcon_picend
            nr-#gcon_picstart
          EndIf
          
          Select EventType()
            Case #PB_EventType_DragStart
              selectedpic(GetGadgetText(#gTXT_picstart+nr))=1
              LoadScreenshots(GetGadgetState(#gSCR_pic))
              
              files$=""
              a$=GetGadgetText(#gBTN_Gamedir)+"/screenshots/"
              ForEach SelectedPic()
                If selectedpic()=1
                  files$+ a$+MapKey(selectedpic())+Chr(10)
                EndIf              
              Next
              If files$
                If DragFiles(files$,#PB_Drag_Copy|#PB_Drag_Move)<>#PB_Drag_None 
                  
                  ClearMap(SelectedPic())
                  LoadScreenshots(GetGadgetState(#gSCR_pic))
                EndIf
                
              EndIf                           
              
            Case #PB_EventType_LeftClick
              selectedpic(GetGadgetText(#gTXT_picstart+nr))!1
              LoadScreenshots(GetGadgetState(#gSCR_pic))
            Case #PB_EventType_RightClick
              selectedpic(GetGadgetText(#gTXT_picstart+nr))=1
              LoadScreenshots(GetGadgetState(#gSCR_pic))
              DisplayPopupMenu(#m_Screen,WindowID(0))
            Case #PB_EventType_LeftDoubleClick
              p$=GetGadgetText(#gBTN_Gamedir)+"/screenshots/"+GetGadgetText(#gTXT_picstart+nr)
              If FileSize(p$)>0
                RunProgram(p$)
              EndIf
          EndSelect
          ;}
          
        Case #gSCR_pic;-{ picscrollbalken
          LoadScreenshots(GetGadgetState(#gSCR_pic))
          ;}
          
        Case #gBTN_Gamedir;-{ gamedir öffnen
          RunProgram(GetGadgetText(#gBTN_Gamedir))
          ;}
          
        Case #gCBX_Dir;-{ dir geändert
          changeGameDir()
          ;}
          
        Case #gCBX_Version;-{ version geändert
          resize_win0(#True)
          ;}
          
          
        Case #gWeb_Start To #gWeb_End;-{ web-info
          Select EventType()
            Case #PB_EventType_DownloadEnd,#PB_EventType_DownloadEnd
              x=EventGadget() 
              SetGadgetText(#gWeb_URL+x-#gweb_start,GetGadgetText(x))
            ;Case #PB_EventType_DownloadStart
              
          EndSelect
          
        
          
          ;}
          
        Case #gBTN_Start;-{ minecraft starten
          StartMinecraft()
          ;}
          
        Case #gLST_Profile;-{ profile
          x=GetGadgetState(#gLST_Profile)
          If lastprof<>x
            StoreProfile(lastprof)
            DisplayProfile(x)
          EndIf
          Select EventType()
            Case #PB_EventType_RightClick
              DisplayPopupMenu(#m_Profile,WindowID(0))
            Case #PB_EventType_DragStart
              If lastprof>1
                StoreProfile(lastprof)
                DragPrivate(1,#PB_Drag_Move)
              EndIf              
          EndSelect
          ;}
          
      EndSelect
  EndSelect
  
  
ForEver
;debug lastprof


;For I=#g_start+1 To #g_End-1
;  If IsGadget(i) 
;    FreeGadget(i)
;  EndIf
;  
;Next

;TextGadget(0,5,WindowHeight(0)/2-25-25,WindowWidth(0)-10,20,"Starte "+ver$,#PB_Text_Center|#PB_Text_Border )
;TextGadget(1,5,WindowHeight(0)/2-25,WindowWidth(0)-10,20,"Download",#PB_Text_Center)
;TextGadget(2,5,WindowHeight(0)/2,WindowWidth(0)-10,20,"",#PB_Text_Center)


;DisableWindow(0,#True)

;}

StoreProfile(lastprof)
curprof$=profiles()\title

;-{ Preferences sichern
DeleteFile("minecraftstart.ini")
CreatePreferences(#title+".ini")
WritePreferenceString("naMCl",namcl_version)
WritePreferenceLong("naMCl_update",namcl_doupdate)
WritePreferenceLong("Offline-Mode",offline)
WritePreferenceLong("ForceLogin",ForceLogin)
WritePreferenceString("StartTab",StartTab$)
WritePreferenceLong("ShowSnap",ShowSnap)
WritePreferenceString("release",curver$)
WritePreferenceString("snapshot",cursnap$)
WritePreferenceString("profile",curprof$)
WritePreferenceString("TwitchToken",crypt("twitch",GetGadgetText(#gHST_TwitchToken),ListSize(profiles())))


PreferenceGroup("Web")
For i=0 To #MaxWebCount
  If webs(i)\name<>""
    a$=ReplaceString(webs(i)\name," ","_")
    ;debug a$
    WritePreferenceString(a$,webs(i)\url)
  EndIf
Next
PreferenceGroup("Server.properties")
ForEach ServerOptions()
  WritePreferenceString(ServerOptions()\key,ServerOptions()\value)
Next



i=0
c=ListSize(profiles())
ForEach profiles()
  PreferenceGroup("Profile_"+Str(i)):i+1
  WritePreferenceString("titel",profiles()\title)
  WritePreferenceString("Name",profiles()\minename)
  WritePreferenceString("Version",profiles()\ver)
  WritePreferenceString("gamedir",profiles()\gamedir)
  WritePreferenceString("javaw.exe",profiles()\prg);"C:\Program Files\Java\jre7\bin\javaw.exe"
  WritePreferenceLong("dojavaArg",profiles()\doPrgArg)
  WritePreferenceString("javaArg",profiles()\prgarg)
  WritePreferenceString("password",crypt(profiles()\minename,profiles()\password,c))
  WritePreferenceLong("doServerArg",profiles()\doServerPrgArg)
  WritePreferenceString("ServerArg",profiles()\Serverprgarg)
  WritePreferenceLong("BorderlessWindow",profiles()\BorderlessWindow)
  WritePreferenceLong("doServer",profiles()\doServer)
  WritePreferenceString("Server",profiles()\server)
  
  If profiles()\lastlogin=profiles()\minename
    WritePreferenceString("LastLogin",profiles()\lastlogin)
    WritePreferenceString("LastName",crypt(profiles()\lastlogin,profiles()\lastminename,c))
    WritePreferenceString("LastUUID",crypt(profiles()\lastlogin,profiles()\lastuuid,c))
    WritePreferenceString("LastUserType",crypt(profiles()\lastlogin,profiles()\lastusertype,c))    
  EndIf
  
  
  
Next


ClosePreferences()


CloseWindow(0)

;}



Procedure StartMinecraft(forceserver$="")
  StoreProfile(lastprof)
  curprof$=profiles()\title
  
  
  minename$=GetGadgetText(#gSTR_Name)
  prg$=GetGadgetText(#gSTR_JavaExe)
  If GetGadgetState(#gCHK_JavaArg)
    prgarg$=GetGadgetText(#gSTR_JavaArg)
  Else
    prgarg$=""
  EndIf
  
  ;debug "-----"
  ;debug prgarg$
  ;debug "------"
  SelectElement(mines(),GetGadgetState(#gCBX_Version))
  defgamedir$=GetGadgetText(#gCBX_Dir)
  password$=GetGadgetText(#gSTR_Password)
  BorderlessWindow=GetGadgetState(#gCHK_BorderlessWindow)
  If forceserver$=""
    If GetGadgetState(#gCHK_ServerIP)
      server$=GetGadgetText(#gSTR_ServerIP)
    Else
      server$=""
    EndIf    
  Else
    server$=forceserver$
  EndIf
  
  twitch$=GetGadgetText(#gHST_TwitchToken)
  If twitch$
    userprop$=Chr(34)+"twitch_access_token"+Chr(34)+":["+Chr(34)+twitch$+Chr(34)+"]"
  Else
    userprop$=""
  EndIf
  
  
  ver$=mines()\dir
  downloadable=mines()\downloadable
  
  
  dostep=0
  
  openwininfo(ver$)
  ;-{ auth

    wininfo("Login","",(dostep*100)/5):dostep+1    
    usertype$="legacy"
    
    If ForceLogin And password$="" And offline=#False
      
      password$=InputRequester(#Title,"Password","",#PB_InputRequester_Password)
      If password$=""
        CloseWinInfo()
        ProcedureReturn 0
      EndIf
      
    EndIf
    
      If offline=#False And password$<>"" 
        j$=Mojang_Auth(minename$,password$)
        err$=getkey("error",@j$)
        If err$
          err2$=getkey("errorMessage",@j$)
          MessageRequester(#title+" - "+err$,err2$)
          CloseWinInfo()
          ProcedureReturn 0
        Else
          token$=getkey("accessToken",@j$)
          key$=getkey("selectedProfile",@j$)
          minename$=getkey("name",@key$)
          uuid$=getkey("id",@key$)
          If getkey("legacy",@key$)="true"
            usertype$="legacy"
          Else
            usertype$="mojang"
          EndIf
          SetGadgetText(#ghst_lastlogin,profiles()\minename)
          SetGadgetText(#ghst_lastminename,minename$)
          SetGadgetText(#ghst_lastuuid,uuid$)
          SetGadgetText(#ghst_lastusertype,usertype$)
          
          
        EndIf
      ElseIf profiles()\lastlogin=profiles()\minename
        minename$=GetGadgetText(#ghst_lastminename)
        uuid$=GetGadgetText(#ghst_lastuuid)
        usertype$=GetGadgetText(#ghst_lastusertype    )
      ElseIf ForceLogin
        MessageRequester(#title,"Please switch first to Online and login once!")
        CloseWinInfo()
        ProcedureReturn 0
      EndIf
      
    
  ;}
  
  If ver$="current"
    ver$=curver$
  EndIf
  If ver$="current_snap"
    ver$=cursnap$
  EndIf
  
  
  doinfo=#True
  
  wininfo1("Download")
  
  downloaderror=#False
  
  wininfo("Version","",(dostep*100)/5):dostep+1
  ;-{ Version downloaden
  
  If downloadable
    CreateDirectory(minedir$+"\versions\"+ver$)
    GetFile("http://s3.amazonaws.com/Minecraft.Download/versions/"+ver$+"/"+ver$+".jar",minedir$+"\versions\"+ver$+"\"+ver$+".jar")
    GetFile("http://s3.amazonaws.com/Minecraft.Download/versions/"+ver$+"/minecraft_server."+ver$+".jar",minedir$+"\versions\"+ver$+"\minecraft_server."+ver$+".jar",#False)
    GetFile("http://s3.amazonaws.com/Minecraft.Download/versions/"+ver$+"/"+ver$+".json",minedir$+"\versions\"+ver$+"\"+ver$+".json")
  EndIf
  
  
  json$=MyLoadJSON(minedir$+"\versions\"+ver$+"\"+ver$+".json")
  
  id$=getkey("id",@json$)
  
  arg$= getkey("minecraftArguments",@json$)
  
  mainClass$=getkey("mainClass",@json$)
  assindex$=getkey("assets",@json$,"legacy")
  minlauncher$=getkey("minimumLauncherVersion",@json$,"0")
  type$=getkey("type",@json$,"unknown")
  ;}
  
  ;-{ Bibliotheken-liste aufbauen und natives entpacken
  
  wininfo("Libraries","",(dostep*100)/5):dostep+1
  
  nativesdir$=minedir$+"\versions\"+ver$+"\natives";+Hex(Date())
  CreateDirectory(nativesdir$)
  
  
  CreateDirectory(minedir$+"\libraries")
  a$=getkey("libraries",@json$)
  
  c=0
  liblist$=""
  Repeat
    b$=splitjson(@a$,c)
    If b$="":Break:EndIf
    
    
    lib$=getkey("name",@b$)
    
    libpack$=StringField(lib$,1,":")
    libname$=StringField(lib$,2,":")
    libver$=StringField(lib$,3,":")
    
    
    file$=minedir$+"\libraries\"+ReplaceString(libpack$,".","_")+"_"+libname$+"-"+libver$
    url$=getkey("url",@b$,"https://libraries.minecraft.net/")+ReplaceString(libpack$,".","/")+"/"+libname$+"/"+libver$+"/"+libname$+"-"+libver$
    ;https://libraries.minecraft.net/com/mojang/realms/1.3.1/realms-1.3.1.jar
    ;https://libraries.minecraft.net/com/majong/realms/1.3.4/realms-1.3.4-.jar
    rule$=getkey("rules",@b$)
    do=#True
    If rule$
      r=0
      Repeat
        r$=SplitJson(@rule$,r)
        If r$=""
          Break
        EndIf
        If FindString(r$,Chr(34)+"allow"+Chr(34))>0 And FindString(r$,"windows")=0 And FindString(r$,Chr(34)+"name"+Chr(34))>0
          do=#False
        EndIf
        If FindString(r$,Chr(34)+"disallow"+Chr(34)) And FindString(r$,"windows")
          do=#False
        EndIf
        
        
        r+1
      ForEver
      
      
    EndIf
    
    If do
      natives$=getkey("natives",@b$)
      If natives$=""
        GetFile(url$+".jar",file$+".jar")
        If liblist$
          liblist$+";"
        EndIf
        liblist$+file$+".jar"
      Else
        add$=GetKey("windows",@natives$)
        add$=ReplaceString(add$,"${arch}",#bitvers)
          
        GetFile(url$+"-"+add$+".jar",file$+"-"+add$+".jar")
        
        
        
        If OpenPack(0, file$+"-"+add$+".jar",#PB_PackerPlugin_Zip) 
          reftime=GetFileDate(file$+"-"+add$+".jar",#PB_Date_Modified)
          
          ; Listet alle Einträge auf
          If ExaminePack(0)
            While NextPackEntry(0)
              pfile$=PackEntryName(0)
              If Left(pfile$,9)<>"META-INF/"
                If PackEntryType(0)=#PB_Packer_File       
                  If PackEntrySize(0)<>FileSize(nativesdir$+"\"+pfile$) Or GetFileDate(nativesdir$+"\"+pfile$,#PB_Date_Modified)<>reftime
                    wininfo2("uncompress "+pfile$)
                    UncompressPackFile(0,nativesdir$+"\"+pfile$)
                    SetFileDate(nativesdir$+"\"+pfile$,#PB_Date_Modified,reftime)
                  EndIf
                  
                Else
                  CreateDirectory(nativesdir$+"\"+pfile$)
                EndIf
              EndIf
            Wend
          EndIf
          
          ClosePack(0)
        EndIf
        
        
        
      EndIf
    EndIf
    
    c+1
  ForEver
  
  
  
  liblist$+";"+minedir$+"\versions\"+ver$+"\"+id$+".jar"
  ;}
  
  
  ;-{ assets
  wininfo("Assets","",(dostep*100)/5):dostep+1
  CreateDirectory(minedir$+"\assets")
  CreateDirectory(minedir$+"\assets\indexes")
  CreateDirectory(minedir$+"\assets\objects")
  CreateDirectory(minedir$+"\assets\skins")
  
  getfile("https://s3.amazonaws.com/Minecraft.Download/indexes/"+assindex$+".json",minedir$+"\assets\indexes\"+assindex$+".json")
  
  ;md5$= MD5FileFingerprint(minedir$+"\assets\indexes\"+assindex$+".json")
  
  ;If md5$<>GetFileToken(minedir$+"\assets\indexes\"+assindex$+".json.md5")
  asjson$=MyLoadJSON(minedir$+"\assets\indexes\"+assindex$+".json")
  If GetKey("virtual",@asjson$)
    virtual=#True
    assvirtual$=minedir$+"\assets\virtual\"+assindex$
  Else
    virtual=#False
  EndIf
  
  
  objects$=GetKey("objects",@asjson$)
  
  i=0
  allsize=0
  downsize=0
  Repeat
    a$=SplitJson(@objects$,i)
    If a$="" 
      Break
    EndIf
    g=FindString(a$,":")
    key$=Left(a$,g-1)
    If Left(key$,1)=Chr(34): key$=Mid(key$,2,Len(key$)-2) : EndIf
    j$=Right(a$,Len(a$)-g)
    hash$=GetKey("hash",@j$)
    size=Val(getkey("size",@j$))
    allsize+size
    file$=minedir$+"\assets\objects\"+Left(hash$,2)+"\"+hash$
    
    
    
    If FileSize(file$)<>size
      CreateDirectory(GetPathPart(file$))
      DeleteFile(file$)
      getfile("http://resources.download.minecraft.net/"+Left(hash$,2)+"/"+hash$,file$,#True,#False,key$)    
    EndIf
    downsize+FileSize(file$)  
    
    If virtual
      k$=ReplaceString(key$,"/","\")
      ForceDirectories(assvirtual$+"\"+GetPathPart(k$))
      CopyFile(file$,assvirtual$+"\"+k$)
    EndIf
    
    
    
    i+1
  ForEver
  If downsize<>allsize
    downloaderror=#True
    downloaderrlist$+"Asserts-Größen-Fehler"+Chr(10)
    ;SetFileToken(minedir$+"\assets\indexes\"+assindex$+".json.md5",md5$)
  EndIf
  ;EndIf
  ;}
  
  
  
  
  
  ;-{ gamedir
  ;CreateDirectory(minedir$+"\gamedir")
  gamedir$=CreateGameDir(defgamedir$,id$,type$,curprof$)
  forceDirectories(gamedir$)
  
  ;}
  
  
  
  ;-{ Programm starten
  wininfo("Start","",(dostep*100)/5):dostep+1
  If uuid$=""
    uuid$=MD5Fingerprint(@minename$,Len(minename$))
  EndIf
  If token$=""
    token$="none";ReverseString(uuid$)
  EndIf
  
  
  
  ;"+chr(34)+"
  
  ;para$="-XX:HeapDumpPath=MojangTricksIntelDriversForPerformance_javaw.exe_minecraft.exe.heapdump -Xmx1G -XX:+UseConcMarkSweepGC -XX:+CMSIncrementalMode -XX:-UseAdaptiveSizePolicy -Xmn128M "
  para$=prgarg$+" ";"-XX:HeapDumpPath=MojangTricksIntelDriversForPerformance_javaw.exe_minecraft.exe.heapdump -Xmx"+memmax$+" -XX:+UseConcMarkSweepGC -XX:+CMSIncrementalMode -XX:-UseAdaptiveSizePolicy -Xmn"+memmin$+" "
  
  ;para$+" -Djava.library.path=C:\Users\GPI\AppData\Roaming\.minecraft\versions\1.7.10\1.7.10-natives-save"; 
  para$+" "+Chr(34)+"-Djava.library.path="+nativesdir$+Chr(34)
  
  ;para$+" -cp C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\mojang\realms\1.3.3\realms-1.3.3.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\apache\commons\commons-compress\1.8.1\commons-compress-1.8.1.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\apache\httpcomponents\httpclient\4.3.3\httpclient-4.3.3.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\commons-logging\commons-logging\1.1.3\commons-logging-1.1.3.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\apache\httpcomponents\httpcore\4.3.2\httpcore-4.3.2.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\java3d\vecmath\1.3.1\vecmath-1.3.1.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\net\sf\trove4j\trove4j\3.0.3\trove4j-3.0.3.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\ibm\icu\icu4j-core-mojang\51.2\icu4j-core-mojang-51.2.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\net\sf\jopt-simple\jopt-simple\4.5\jopt-simple-4.5.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\paulscode\codecjorbis\20101023\codecjorbis-20101023.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\paulscode\codecwav\20101023\codecwav-20101023.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\paulscode\libraryjavasound\20101123\libraryjavasound-20101123.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\paulscode\librarylwjglopenal\20100824\librarylwjglopenal-20100824.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\paulscode\soundsystem\20120107\soundsystem-20120107.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\io\netty\netty-all\4.0.10.Final\netty-all-4.0.10.Final.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\google\guava\guava\15.0\guava-15.0.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\apache\commons\commons-lang3\3.1\commons-lang3-3.1.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\commons-io\commons-io\2.4\commons-io-2.4.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\commons-codec\commons-codec\1.9\commons-codec-1.9.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\net\java\jinput\jinput\2.0.5\jinput-2.0.5.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\net\java\jutils\jutils\1.0.0\jutils-1.0.0.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\google\code\gson\gson\2.2.4\gson-2.2.4.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\com\mojang\authlib\1.5.16\authlib-1.5.16.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\apache\logging\log4j\log4j-api\2.0-beta9\log4j-api-2.0-beta9.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\apache\logging\log4j\log4j-core\2.0-beta9\log4j-core-2.0-beta9.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\lwjgl\lwjgl\lwjgl\2.9.1\lwjgl-2.9.1.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\org\lwjgl\lwjgl\lwjgl_util\2.9.1\lwjgl_util-2.9.1.jar;C:\Users\GPI\AppData\Roaming\.minecraft\libraries\tv\twitch\twitch\5.16\twitch-5.16.jar;C:\Users\GPI\AppData\Roaming\.minecraft\versions\1.7.10\1.7.10.jar"; 
  para$+" -cp "+Chr(34)+liblist$+Chr(34)
  
  ;para$+" net.minecraft.client.main.Main"; 
  para$+" "+mainClass$
  
  ;para$+" --username "+minename$;GePeIe"; 
  ;para$+" --version 1.7.10"; 
  ;para$+" --gameDir C:\Users\GPI\AppData\Roaming\.minecraft"; 
  ;para$+" --assetsDir C:\Users\GPI\AppData\Roaming\.minecraft\assets"; 
  ;para$+" --assetIndex 1.7.10"; 
  ;para$+" --uuid "+uuid$
  ;para$+" --accessToken "+token$
  ;para$+" --userProperties {} --userType legacy"
  
  arg$=ReplaceString(arg$,"${auth_player_name}",minename$)
  arg$=ReplaceString(arg$,"${version_name}",id$)
  arg$=ReplaceString(arg$,"${game_directory}",Chr(34)+gamedir$+Chr(34))
  arg$=ReplaceString(arg$,"${assets_root}",Chr(34)+minedir$+"\assets"+Chr(34))
  arg$=ReplaceString(arg$,"${assets_index_name}",assindex$)
  
  arg$=ReplaceString(arg$,"${auth_uuid}",uuid$)
  arg$=ReplaceString(arg$,"${auth_access_token}",token$)
  arg$=ReplaceString(arg$,"${user_properties}","{"+userprop$+"}")
  arg$=ReplaceString(arg$,"${user_type}",usertype$)
  
  arg$=ReplaceString(arg$,"${auth_session}","token:"+token$)
  arg$=ReplaceString(arg$,"${game_assets}",Chr(34)+assvirtual$+Chr(34))
  
  para$+" "+arg$;+" --server 192.168.0.2 ";-------
  If server$
    para$+" --server "+server$
  EndIf
  
  
  If FindString(arg$,"${")>0
    MessageRequester("MineStarter - unbekannter Parameter",arg$)
  EndIf
  
  ;debug "run:"+prg$
  ;debug "para:"+para$
  ;debug "dir:"+minedir$
  
  
  If downloaderror=#False
    
    ;CreateThread(@maxmine(),0)
    hPrg = RunProgram(prg$, para$, minedir$,#PB_Program_Open)
    
    If BorderlessWindow
      minewin.l=0
      i=0
      While ProgramRunning(hPrg) And i<99
        EnumWindows_(@EnumWin(),@minewin)
        If minewin
          Repeat
            Delay(1000)
          Until IsWindowVisible_(minewin)
          
          ;EnumWindows_(@EnumWin(),@minewin)
          ;ShowWindow_(minewin,#SW_MAXIMIZE)
          ;SetWindowLongPtr_(minewin, #GWL_STYLE, GetWindowLongPtr_(minewin, #GWL_STYLE) & ~(#WS_CAPTION) | #WS_SYSMENU)
          ;Debug a
          ;SetWindowPos_(minewin,0,0.0,0,0,0,#SWP_NOMOVE | #SWP_NOSIZE | #SWP_NOZORDER | #SWP_FRAMECHANGED)
          
          SystemParametersInfo_(#SPI_GETWORKAREA,0,rect.RECT,0) 
          AdjustWindowRectEx_(rect,
                              GetWindowLongPtr_(minewin, #GWL_STYLE),
                              #False,
                              GetWindowLongPtr_(minewin, #GWL_EXSTYLE))

          
          SetWindowPos_(minewin,0,rect\left,
                        rect\top,
                        rect\right-rect\left,
                        rect\bottom-rect\top,#SWP_ASYNCWINDOWPOS|#SWP_NOOWNERZORDER)
          
          


          
          
          
          Break
        EndIf    
        Delay(500)
        i+1
      Wend
    EndIf
    ;WaitProgram(hprg)
    
  Else
    MessageRequester("Minestarter - Downloadfehler!",downloaderrlist$)
  EndIf
  
  
  ;DeleteDirectory(nativesdir$, "*.*",#PB_FileSystem_Recursive|#PB_FileSystem_Force    )
  ;}
  doinfo=#False
  CloseWinInfo()
  
EndProcedure



; IDE Options = PureBasic 5.30 (Windows - x64)
; CursorPosition = 3108
; FirstLine = 2702
; Folding = n-f+--5wzxC7t-
; EnableThread
; EnableXP
; UseIcon = Minecraft\icon.ico
; Executable = F:\minecraft\namcl.exe
; CurrentDirectory = F:\minecraft\
; EnablePurifier
; EnableCompileCount = 11
; EnableBuildCount = 4
; IncludeVersionInfo
; VersionField0 = %BUILDCOUNT.%yy.%mm.%dd
; VersionField1 = %BUILDCOUNT.%yy.%mm.%dd
; VersionField2 = GPI
; VersionField3 = NAMCL3
; VersionField4 = %BUILDCOUNT.%yy.%mm.%dd
; VersionField5 = %BUILDCOUNT.%yy.%mm.%dd
; VersionField6 = Not Another Minecraft Launcher
; VersionField7 = NAMCL
; VersionField8 = NAMCL.EXE